﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Chat.aspx.cs" Inherits="Medweb.Cloud.Web.Site.ChatPage" %>

<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <meta charset="utf-8" />
    <%--<meta name="viewport" content="width=device-width" />--%>
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=0" />
    <meta name="mobile-web-app-capable" content="yes">
    <link rel="icon" sizes="128x128" href="/images/first_aid.png" />

    <title>Medweb Waiting Room</title>
    <script type="text/javascript">
        <asp:Literal ID="js" runat="server"></asp:Literal>
    </script>

    <link href="/styles/bootstrap.min.css" rel="stylesheet" />
    <link href="/styles/bootstrap-theme.min.css" rel="stylesheet" />
    <link href="/styles/Chat.css" rel="stylesheet" />
    <script type="text/javascript" src="/scripts/Scripts.js?target=core&<%=Medweb.Cloud.Web.Site.Utilities.GetJSQueryString() %>"></script>

    <script type="text/javascript" src="/scripts/jquery.validate.min.js?1"></script>
    <script type="text/javascript" src="/scripts/bootstrap.min.js?1"></script>
    <script type="text/javascript" src="/scripts/bootbox.min.js?1"></script>

    <script src="/scripts/bx-slider/plugins/jquery.fitvids.js"></script>
    <script src="/scripts/bx-slider/jquery.bxslider.js"></script>
    <script src="/scripts/simpleWeather/jquery.simpleWeather.js"></script>
    <link href="/scripts/bx-slider/jquery.bxslider.css" rel="stylesheet" />

    <script type="text/javascript" src="/scripts/jquery.rss.js"></script>
    <script type="text/javascript" src="/scripts/fm/fm.min.js?1"></script>
    <script type="text/javascript" src="/scripts/fm/fm.therest.min.js?1"></script>
    <script type="text/javascript" src="/scripts/fm/fm.websync.min.js?1"></script>
    <script type="text/javascript" src="/scripts/fm/fm.websync.subscribers.min.js?1"></script>
    <script type="text/javascript" src="/scripts/fm/fm.websync.chat.min.js?1"></script>
    <script type="text/javascript" src="/scripts/fm/fm.icelink.min.js?1"></script>
    <script type="text/javascript" src="/scripts/fm/fm.icelink.webrtc.js?1"></script>
    <!-- removed .min -->
    <script type="text/javascript" src="/scripts/fm/fm.icelink.websync.min.js?1"></script>

    <script type="text/javascript" src="/scripts/soundmanager/script/soundmanager2-nodebug-jsmin.js?1"></script>
    <script type="text/javascript" src="/scripts/app/Shared.js?1"></script>

    <style type="text/css">
        .topbar {
            background: #FFFF99;
            border-bottom: solid 1px #ccc;
            padding: 5px 0;
            text-align: center;
            color: #000;
        }

        ​
    </style>

    <script type="text/javascript">

        var topBar = function(message){
            $("<div />", { 'class': 'topbar', html: message }).hide().prependTo("body")
                .slideDown('fast').delay(10000).slideUp(function() { $(this).remove(); });
        };

        // Opera 8.0+
        var isOpera = (!!window.opr && !!opr.addons) || !!window.opera || navigator.userAgent.indexOf(' OPR/') >= 0;

        // Firefox 1.0+
        var isFirefox = typeof InstallTrigger !== 'undefined';

        // Safari 3.0+ "[object HTMLElementConstructor]"
        var isSafari = Object.prototype.toString.call(window.HTMLElement).indexOf('Constructor') > 0 || (function (p) { return p.toString() === "[object SafariRemoteNotification]"; })(!window['safari'] || safari.pushNotification);

        // Internet Explorer 6-11
        var isIE = /*@cc_on!@*/false || !!document.documentMode;

        // Edge 20+
        var isEdge = !isIE && !!window.StyleMedia;

        // Chrome 1+
        var isChrome = !!window.chrome && !!window.chrome.webstore;

        // Blink engine detection
        var isBlink = (isChrome || isOpera) && !!window.CSS;

        $workflows = {};
        var urlParams;
        (window.onpopstate = function () {
            var match,
                pl     = /\+/g,  // Regex for replacing addition symbol with a space
                search = /([^&=]+)=?([^&]*)/g,
                decode = function (s) { return decodeURIComponent(s.replace(pl, " ")); },
                query  = window.location.search.substring(1);

            urlParams = {};
            while (match = search.exec(query))
                urlParams[decode(match[1])] = decode(match[2]);

            console.log(urlParams);
        })();

        $(document).ready(function(){
            if(!isChrome && !isFirefox){
                topBar('Our apologies, your browser has limited support for Medweb Cloud. Please consider <a href="#">Firefox</a> or <a href="#">Chrome</a> for a better experience.');
            }
            $workflow = {};

            var workflow = (urlParams['workflow'] || 'standard').toLowerCase();
            if(!$('#' + workflow).length){
                workflow = 'standard';
            }
            console.log('starting workflow ' + workflow);
            var markup = $('#' + workflow).html();
            $('#primary-workflow-container').html(markup);
            $workflow.start();
        });
    </script>

    <script type="text/javascript" src="/scripts/app/chat/Chat.js?1"></script>
    <script type="text/javascript" src="/scripts/app/chat/ChatVideo.js?1"></script>
    <script type="text/javascript" src="//afneurope.net/controls/mediaplayer/jwplayer.js"></script>
    <link href="//netdna.bootstrapcdn.com/bootstrap/3.0.0/css/bootstrap-glyphicons.css" rel="stylesheet" />
</head>
<body>
    <div class="container" id="chatRequest">
        <div class="panel panel-default">
            <div class="panel-heading clearfix">
                <button type="button" class="btn btn-info pull-right collage-user collage-user-loading" data-toggle="modal" data-target="#collageUserLoginForm"><span class="glyphicon glyphicon-user" aria-hidden="true"></span><span class="btnText collage-user-text">{i:medweb.cloud.evisit.visitor.login.label}</span></button>
                <h3><span class="glyphicon glyphicon-plus"></span>Medweb E-Visit</h3>
                <p class="text-muted" id="chatFormStatus">{i:medweb.cloud.evisit.visitor.instructions.label}</p>
            </div>

            <div class="panel-body" id="primary-workflow-container">
                <script type="text/html" id="standard">
                    <form role="form" id="chatRequestForm">
                        <input type="hidden" name="Workflow" value="Standard" />
                        <div class="form-group">
                            <label for="nameField">{i:medweb.cloud.evisit.visitor.name.label}:</label>
                            <input type="text" class="form-control" id="nameField" name="Name" />
                        </div>

                        <div class="form-group">
                            <label for="emailInput">{i:medweb.cloud.evisit.visitor.email.label}:</label>
                            <input type="text" class="form-control" id="emailInput" name="Email" />
                        </div>

                        <div class="form-group">
                            <label for="identifierField">{i:medweb.cloud.evisit.visitor.identifier.label}:</label>
                            <div class="input-group identifier-group">
                                <select id="id-type" class="form-control identifier-control-type" name="IdentifierType">
                                    <option value="SSN">SSN</option>
                                    <option value="EID">EID</option>
                                    <option value="TIN">TIN</option>
                                    <option value="FIN">FIN</option>
                                    <option value="ITIN">ITIN</option>
                                    <option value="PIN">PIN</option>
                                </select>
                                <input type="text" class="form-control  identifier-control-id" id="identifierField" name="Identifier" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="questionField">{i:medweb.cloud.evisit.visitor.describeissue.label}:</label>
                            <textarea id="questionField" class="form-control" rows="5" name="Question"></textarea>
                        </div>

                        <button class="btn btn-primary" id="beginChatBtn">
                            <span class="glyphicon glyphicon-earphone"></span><span class="btnText" id="jerod">{i:medweb.cloud.evisit.visitor.beginvisit.label}</span>
                        </button>
                    </form>

                    <script type="text/javascript">
                        $workflow.start = function(){
                            $('#chatRequestForm').data('done', true);
                        };
                    </script>
                </script>
                <script type="text/html" id="testresults">
                    <form role="form" id="chatRequestForm">
                        <input type="hidden" name="Workflow" value="TestResults" />
                        <div class="form-group">
                            <label for="first">First Name</label><input id="first" type="text" class="form-control" name="FirstName" />
                        </div>
                        <div class="form-group">
                            <label for="last">Last Name</label><input id="last" type="text" class="form-control" name="LastName" />
                        </div>
                        <div class="form-group">
                            <label for="emailField">Email:</label>
                            <input type="text" class="form-control" id="emailField" name="Extra.Email" />
                        </div>
                        <div class="form-group">
                            <label for="phoneField">Phone:</label>
                            <input type="text" class="form-control" id="phoneField" name="Extra.Phone" />
                        </div>

                        <div class="form-group">
                            <label for="nameField">Appointment Code:</label>
                            <input type="text" class="form-control" id="appointmentCode" name="Email" />
                            <input type="hidden" name="IdentifierType" value="AppointmentCode" />
                        </div>

                        <button class="btn btn-primary" id="beginChatBtn">
                            <span class="glyphicon glyphicon-earphone"></span><span class="btnText">{i:medweb.cloud.evisit.visitor.beginvisit.label}</span>
                        </button>
                    </form>

                    <script type="text/javascript">
                        $workflow.start = function(){
                            $('#chatRequestForm').data('done', true);
                        };
                    </script>
                </script>
                <script type="text/html" id="standardalt">
                    <form role="form" id="chatRequestForm">
                        <input type="hidden" name="Workflow" value="StandardAlternate" />
                        <div class="form-group" id="seen-before">
                            <label for="haveWeSeenYou">Have we seen you before?</label>
                            <div>
                                <label for="haveWeSeenYouYes">Yes</label>
                                <input type="radio" id="haveWeSeenYouYes" name="haveWeSeenYou" value="Yes" />
                                <label for="haveWeSeenYouNo">No</label>
                                <input type="radio" id="haveWeSeenYouNo" name="haveWeSeenYou" value="No" />
                            </div>
                        </div>

                        <div id="flow-1-1">
                            <div class="form-group">
                                <label for="phone1">Please enter your phone number</label>
                                <div>
                                    <input id="phone1" type="text" class="form-control" />
                                </div>
                                <br />
                                <button class="btn btn-primary" id="findAccount">
                                    <span class="glyphicon glyphicon-user"></span><span class="btnText">Find My Account</span>
                                </button>
                            </div>
                        </div>

                        <div id="flow-2-1">
                            <label>Please enter your personal information below:</label>
                            <div class="form-group">
                                <label for="first">First Name</label><input id="first" type="text" class="form-control" name="FirstName" />
                            </div>
                            <div class="form-group">
                                <label for="last">Last Name</label><input id="last" type="text" class="form-control" name="LastName" />
                            </div>
                            <div class="form-group">
                                <label for="email">Email</label><input id="email" type="text" class="form-control" name="Extra.Email" />
                            </div>
                            <div class="form-group">
                                <label for="phone">Phone</label><input id="phone" type="text" class="form-control" name="Extra.Phone" />
                            </div>

                            <button class="btn btn-primary" id="continue">
                                <span class="glyphicon glyphicon-user"></span><span class="btnText">Continue</span>
                            </button>
                        </div>

                        <div id="flow-3">
                            <div class="form-group">
                                <label for="questionField">Reason for Visit:</label>
                                <textarea id="questionField" class="form-control" rows="5" name="Question"></textarea>
                            </div>

                            <div class="form-group">
                                <input id="terms" type="checkbox" name="AcceptTerms" value="Yes" />
                                <label for="consent">I agree to the <a href="/CONSENT_ACME-Health-System.rtf" target="_blank">terms and conditions</a></label>
                            </div>

                            <button class="btn btn-primary" id="beginChatBtn">
                                <span class="glyphicon glyphicon-earphone"></span><span class="btnText">Begin E-Visit</span>
                            </button>
                        </div>
                    </form>

                    <script type="text/javascript">

                        $workflow.start = function(){
                            var directory = [
                                { phone: '9193005141', first: 'Jerod', last: 'Venema', email: 'jerod.venema@frozenmountain.com' },
                                { phone: '3057751491', first: 'Scott', last: 'Simmons', email: 'ssimmons@medweb.com' }
                            ]

                            var hideAll = function () {
                                $('#flow-1-1, #flow-2-1, #flow-3').hide();
                                $('#seen-before').hide();
                            }

                            hideAll();
                            $('#seen-before').show();

                            $('#haveWeSeenYouYes').click(function () {
                                hideAll();
                                $('#flow-1-1').show();
                            });

                            $('#haveWeSeenYouNo').click(function () {
                                hideAll();
                                $('#flow-2-1').show();
                            });

                            $('#continue').click(function () {
                                hideAll();
                                $('#flow-3').show();
                                $('#chatRequestForm').data('done', true);

                                return false;
                            });

                            $('#findAccount').click(function () {
                                hideAll();

                                // flow 2-1, fill it out and continue
                                var search = $('#phone1').val();

                                for (var i = 0; i < directory.length; i++) {
                                    if (directory[i].phone == search) {
                                        $('#flow-2-1 input').each(function () {
                                            var id = $(this).attr('id');
                                            $(this).val(directory[i][id]);
                                        })
                                    }
                                }
                                $('#flow-2-1').show();

                                $('#chatRequestForm').data('done', true);
                                return false;
                            });
                        };
                    </script>
                </script>
                <script type="text/html" id="visitapatient">
                    <form role="form" id="chatRequestForm">
                        <input type="hidden" name="Workflow" value="VisitPatient" />
                        <div id="flow-1">
                            <label>Please enter your personal information below:</label>
                            <div class="form-group">
                                <label for="first">First Name</label><input id="first" type="text" class="form-control" name="FirstName" />
                            </div>
                            <div class="form-group">
                                <label for="last">Last Name</label><input id="last" type="text" class="form-control" name="LastName" />
                            </div>
                            <div class="form-group">
                                <label for="email">Email</label><input id="email" type="text" class="form-control" name="Extra.Email" />
                            </div>
                            <div class="form-group">
                                <label for="phone">Phone</label><input id="phone" type="text" class="form-control" name="Extra.Phone" />
                            </div>
                            <div class="form-group">
                                <div class="input-group-btn">
                                    <label for="relation">Relation to Patient:</label>
                                    <div class="input-group">
                                        <select id="relation" class="form-control" name="Extra.Relation">
                                            <option value="Spouse">Spouse</option>
                                            <option value="Child">Child</option>
                                            <option value="Sibling">Sibling</option>
                                            <option value="OtherRelative">Other Relative</option>
                                            <option value="Friend">Friend</option>
                                            <option value="CoWorker">Co-Worker</option>
                                            <option value="Clergy">Clergy</option>
                                            <option value="Other">Other</option>
                                        </select>
                                    </div>
                                </div>
                            </div>
                            <button class="btn btn-primary" id="continue">
                                <span class="glyphicon glyphicon-user"></span><span class="btnText">Continue</span>
                            </button>
                        </div>

                        <div id="flow-2">
                            <label>Please enter the patient information below:</label>
                            <div class="form-group">
                                <label for="first">First Name</label><input id="first" type="text" class="form-control" name="Extra.PatientFirstName" />
                            </div>
                            <div class="form-group">
                                <label for="last">Last Name</label><input id="last" type="text" class="form-control" name='Extra.PatientLastName' />
                            </div>
                            <div class="form-group">
                                <label for="roomnum">Room #</label><input id="roomnum" type="text" class="form-control" name="Extra.RoomNumber" />
                            </div>
                            <div class="form-group">
                                <label for="phone">Have you visited this patient before?</label>
                                <div>
                                    <label for="haveYouVisitedYes">Yes</label>
                                    <input type="radio" id="haveYouVisitedYes" name="haveYouVisited" value="Yes" />
                                    <label for="haveYouVisitedNo">No</label>
                                    <input type="radio" id="haveYouVisitedNo" name="haveYouVisited" value="No" />
                                </div>
                            </div>

                            <div class="form-group" id="yesvisitorcode">
                                <label for="visitorcode">Visitor Code</label><input id="visitorcode" type="text" class="form-control" name="Email" /><input type="hidden" name="IdentifierType" value="VisitorCode" />
                            </div>
                            <button class="btn btn-primary" id="beginChatBtn">
                                <span class="glyphicon glyphicon-earphone"></span><span class="btnText">Begin E-Visit</span>
                            </button>

                            <div class="form-group" id="novisitorcode">
                                <label for="visitorcode">A visitor code is required.</label>
                            </div>
                            <button class="btn btn-primary" id="requestCode">
                                <span class="glyphicon glyphicon-earphone"></span><span class="btnText">Request Code</span>
                            </button>
                        </div>
                    </form>

                    <script type="text/javascript">

                        $workflow.start = function(){

                            var hideAll = function () {
                                $('#flow-1, #flow-2').hide();
                                $('#yesvisitorcode').hide();
                                $('#novisitorcode').hide();
                                $('#requestCode').hide();
                                $('#beginChatBtn').hide();
                            }

                            hideAll();
                            $('#flow-1').show();

                            $(document).delegate('#continue', 'click', function (e) {
                                e.preventDefault();

                                hideAll();
                                $('#flow-2').show();

                                $('#chatRequestForm').data('done', true);
                                return false;
                            });

                            $(document).delegate('#haveYouVisitedYes', 'click', function (e) {
                                $('#beginChatBtn').show();
                                $('#yesvisitorcode').show();

                                $('#novisitorcode').hide();
                                $('#requestCode').hide();

                                $('#chatRequestForm').data('done', true);
                            });

                            $(document).delegate('#haveYouVisitedNo', 'click', function (e) {
                                $('#novisitorcode').show();
                                $('#requestCode').show();

                                $('#beginChatBtn').hide();
                                $('#yesvisitorcode').hide();
                            });

                            $(document).delegate('#requestCode', 'click', function (e) {
                                e.preventDefault();

                                // show the UI indicating a code has been sent
                                bootbox.alert('Your request has been submitted and will be evaluated within 24 hours. Please check your email for further instructions.');

                                return false;
                            });

                        };
                    </script>
                </script>
            </div>
        </div>
    </div>

    <div class="container full-wrap" id="chatPanel" style="display: none">
        <div class="panel panel-default full-content full-content-footer">
            <div class="panel-heading full-heading clearfix">
                <button type="button" class="btn btn-info pull-right collage-user collage-user-loading" data-toggle="modal" data-target="#collageUserLoginForm"><span class="glyphicon glyphicon-user" aria-hidden="true"></span><span class="btnText collage-user-text">{i:medweb.cloud.evisit.visitor.login.label}</span></button>
                <h3><span class="glyphicon glyphicon-plus"></span>Medweb E-Visit</h3>
                <p id="chatStatus" class="text-muted">{i:medweb.cloud.evisit.visitor.pleasehold.label}</p>
            </div>
            <div class="full-body-wrap">
                <div class="panel-body full-body">
                    <div id="waiting">
                        <script>
                            window.loadWaiting = function() {
                                $('.loading').hide();
                                $(document).triggerHandler('loadWaiting');
                            }
                        </script>
                        <div class="loading">Loading...</div>
                        <div class="waiting-content row">
                            {c:ChatWaitSection}
                        </div>
                    </div>
                    <div id="active">
                        <div class="toolbar" id='chatToolbar'>
                            <div class="btn-toolbar" role="toolbar" aria-label="Video Tools">
                                <div class="btn-group" role="group" id='chatMuteGroup' style='display: none;'>
                                    <button type="button" class="btn btn-default" id="chatMuteVideoBtn">
                                        <span class="glyphicon glyphicon-pause"></span>
                                        <span class="btnText">{i:medweb.cloud.evisit.visitor.mutevideo.label}</span>
                                    </button>
                                    <button type="button" class="btn btn-default" id="chatMuteAudioBtn">
                                        <span class="glyphicon glyphicon-volume-off"></span>
                                        <span class="btnText">{i:medweb.cloud.evisit.visitor.muteaudio.label}</span>
                                    </button>
                                </div>
                                <div class="btn-group pull-right" role="group" id='chatStartGroup' style='display: none;'>
                                    <button type="button" class="btn btn-primary" id="chatStartVideoBtn" disabled="disabled">
                                        <span class="glyphicon glyphicon-facetime-video"></span>
                                        <span class="btnText">{i:medweb.cloud.evisit.visitor.startvideo.label}</span>
                                    </button>
                                </div>
                                <div class="btn-group pull-right" role="group" id='chatEndGroup' style='display: none;'>
                                    <button type="button" class="btn btn-danger" id="chatEndVideoBtn">
                                        <span class="glyphicon glyphicon-facetime-video"></span>
                                        <span class="btnText">{i:medweb.cloud.evisit.visitor.endvideo.label}</span>
                                    </button>
                                </div>
                            </div>
                        </div>
                        <div id="videoContainer"></div>
                        <div id="chatSurfaceWrap">
                            <div id="chatSurface"></div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="panel-footer full-footer">
                <div class="input-group" id="chatMessageTextBtn">
                    <input type="text" class="form-control" id="chatMessageText" disabled="disabled" />
                    <span class="input-group-btn">
                        <button class="btn btn-primary" type="button" id="chatSendBtn" disabled="disabled">{i:medweb.cloud.evisit.visitor.send.label}</button></span>
                </div>
            </div>
        </div>
    </div>

    <div class="modal" id="pleaseWaitDialog" data-backdrop="static" data-keyboard="false">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h2>{i:medweb.cloud.evisit.visitor.submitting.label}</h2>
                </div>
                <div class="modal-body">
                    <div class="progress progress-striped active">
                        <div class="progress-bar" role="progressbar" style="width: 100%"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="modal " id="collageUserLoginForm" role="dialog" aria-labelledby="collageUserTitle">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <h4 class="modal-title" id="collageUserTitle">{i:medweb.cloud.evisit.visitor.login.label}</h4>
                </div>
                <div class="modal-body">
                    <form id="collageUserLogin">
                        <div class="form-group">
                            <label for="exampleInputEmail1">{i:medweb.user.email.label}</label>
                            <input type="text" name="Username" class="form-control" placeholder="Email" />
                        </div>
                        <div class="form-group">
                            <label for="exampleInputPassword1">{i:medweb.user.password.label}</label>
                            <input type="password" name="Password" class="form-control" placeholder="Password" />
                        </div>
                        <div class="alert alert-danger" role="alert" id="collageUserLoginError" style="display: none;"></div>
                        <button type="submit" class="btn btn-default">{i:medweb.cloud.evisit.visitor.login.label}</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
</body>
</html>