﻿window.MedwebCloud = window.MedwebCloud || {};
// Setup the ExtJS Loader
Ext.Loader.setConfig({
    enabled: true,
    paths: {
        'Ext.ux': '/scripts/app/ux',
    }
});

var bundle = Ext.create('Ext.ux.i18n.Bundle', Ext.apply({
    autoLoad: true,
    listeners: {
        loaded: function () {
            //Apply the host info to bundle data before using it
            var format = function (str, col) {
                col = typeof col === 'object' ? col : Array.prototype.slice.call(arguments, 1);
                return str.replace(/\{\{|\}\}|\{([\w_]+)\}/g, function substitute(m, n) {
                    if (m == "{{") {
                        return "{";
                    } if (m == "}}") {
                        return "}";
                    }
                    return col[n] || '{' + n + '}';
                });
            };
            var hostSubstitution = {}
            Ext.Object.each(MedwebCloud.UIConfig.HostContext || {}, function (key, value, all) {
                this["Host_" + key] = value;
            }, hostSubstitution);

            bundle.each(function (record, idx, count) {
                var newVal = record.get('value');
                record.set('value', format(newVal, hostSubstitution));
            });
            MedwebCloud.getMsg = function () {
                var bdl = bundle;
                return bdl.getMsg.apply(bdl, arguments);
            };

            Ext.onReady(function () {
                var w, performLogin;

                var initToken = Ext.History.getToken();

                var windowTitle = MedwebCloud.getMsg('medweb.reset.window.title');
                var labelDisplayName = MedwebCloud.getMsg('medweb.user.displayname.label');

                var labelRecoverEmail = MedwebCloud.getMsg('medweb.common.account.password.recover.byemail');
                var labelRecoverSMS = MedwebCloud.getMsg('medweb.common.account.password.recover.bysms');

                w = Ext.create('Ext.window.Window', {
                    title: document.title,
                    closable: false,
                    resizable: false,
                    draggable: false,
                    layout: {
                        type: 'vbox',
                        align: 'stretch',
                        pack: 'start',
                    },
                    width: 350,
                    border: false,
                    buttonAlign: 'left',
                    items: [{
                        xtype: 'form',
                        itemId: 'loginForm',
                        defaults: {
                            margin: 10,
                            anchor: '100%'
                        },
                        fieldDefaults: {
                            labelWidth: 120
                        },
                        items: [{
                            xtype: 'panel',
                            border: false,
                            layout: 'fit',
                            style: 'text-align:center',
                            html: '<img src="/images/logo.png" width="235px" height="78px" border="0" alt="Login logo" />' + (window.MWError ? '<br/><br/>' + window.MWError : ''),
                        },
                        {
                            html: '<p>' + MedwebCloud.getMsg('medweb.login.button.reset.label') + '</p>',
                            border: false,
                            style: 'text-align:center',
                        },
                        {
                            xtype: 'panel',
                            border: false,
                            layout: {
                                type: 'hbox',
                                align: 'stretch',
                                pack: 'start',
                            },
                            items: [{
                                xtype: 'button',
                                text: labelRecoverEmail,
                                icon: 'images/email16.png',
                                style: {
                                    marginTop: '5px',
                                    padding: '10px'
                                },
                                handler: function () { window.location.href = '/Reset.aspx'; }
                            }, { border: false, flex: 1, visible: false }, {
                                xtype: 'button',
                                text: labelRecoverSMS,
                                icon: 'images/phone.png',
                                style: {
                                    marginTop: '5px',
                                    padding: '10px'
                                },
                                handler: function () { window.location.href = '/ResetMobile.aspx'; }
                            }],
                            style: 'marginTop: 20px'
                        }],
                    }]
                }).show();

                // make sure it stays centered
                Ext.EventManager.onWindowResize(function () {
                    w.center();
                    if (dlg.isVisible()) {
                        dlg.center();
                    }
                });
                MedwebCloud.ready = true;
            });
        }
    }
}, MedwebCloud.bundle));