﻿window.MedwebCloud = window.MedwebCloud || {};
// Setup the ExtJS Loader
Ext.Loader.setConfig({
    enabled: true,
    paths: {
        'Ext.ux': '/scripts/app/ux',
    }
});

var bundle = Ext.create('Ext.ux.i18n.Bundle', Ext.apply({
    autoLoad: true,
    listeners: {
        loaded: function () {
            //Apply the host info to bundle data before using it
            var format = function (str, col) {
                col = typeof col === 'object' ? col : Array.prototype.slice.call(arguments, 1);
                return str.replace(/\{\{|\}\}|\{([\w_]+)\}/g, function substitute(m, n) {
                    if (m == "{{") {
                        return "{";
                    } if (m == "}}") {
                        return "}";
                    }
                    return col[n] || '{' + n + '}';
                });
            };
            var hostSubstitution = {}
            Ext.Object.each(MedwebCloud.UIConfig.HostContext || {}, function (key, value, all) {
                this["Host_" + key] = value;
            }, hostSubstitution);

            bundle.each(function (record, idx, count) {
                var newVal = record.get('value');
                record.set('value', format(newVal, hostSubstitution));
            });
            MedwebCloud.getMsg = function () {
                var bdl = bundle;
                return bdl.getMsg.apply(bdl, arguments);
            };

            Ext.onReady(function () {
                var w, performLogin;

                var initToken = Ext.History.getToken();

                changeMobilePassword = function () {
                    var form = w.down('#changePasswordForm');
                    var maskMessage = MedwebCloud.getMsg('medweb.view.internalchatfilepanel.column.creationdate.progress.default');
                    var successMessage = MedwebCloud.getMsg('medweb.reset.success.message.passwordreset');
                    var successTitle = MedwebCloud.getMsg('medweb.reset.success.title');

                    if (!form.isValid()) {
                        return;
                    }

                    w.mask(maskMessage);
                    w.down('#changePassword').disable();

                    Ext.Ajax.request({
                        url: MedwebCloud.api('/v3/mobilechangepassword'),
                        method: 'POST',
                        jsonData: {
                            Password: w.down('#password').getValue(),
                            ConfirmPassword: w.down('#confirmPassword').getValue(),
                            Code: w.down('#codefield').getValue(),
                        },
                        success: function (data, options) {
                            var response = JSON.parse(data.responseText);
                            console.log('yae');
                            if (response.status == "success") {
                                Ext.MessageBox.show({
                                    title: successTitle,
                                    msg: successMessage,
                                    buttons: Ext.MessageBox.OK,
                                    fn: function (buttonId) {
                                        if (buttonId === "ok") {
                                            window.location.href = '/Default.aspx';
                                        }
                                    }
                                });
                            } else {
                                el = w.down('#error');
                                el.update(response.message);
                                el.show();
                            }
                        },
                        failure: function (response, options) {
                            console.log('nae');
                            var responseObj = {};
                            try {    // This will fail if not valid json response
                                responseObj = Ext.decode(response.responseText);
                            } catch (e) { }
                            var error = responseObj || response.responseText,
                                el = w.down('#error');

                            el.update(error);
                            el.show();
                        },
                        callback: function () {
                            w.down('#changePassword').enable();
                            w.unmask();
                        }
                    });
                };

                sendMobileCode = function () {
                    var form = w.down('#resetForm');
                    var maskMessage = MedwebCloud.getMsg('medweb.view.internalchatfilepanel.column.creationdate.progress.default');
                    var successMessage = MedwebCloud.getMsg('medweb.reset.success.message.sms');
                    var successTitle = MedwebCloud.getMsg('medweb.reset.success.title');

                    if (!form.isValid()) {
                        return;
                    }

                    w.mask(maskMessage);
                    w.down('#sendCode').disable();

                    Ext.Ajax.request({
                        url: MedwebCloud.api('/v3/mobileresetcode'),
                        method: 'POST',
                        dataType: 'json',
                        jsonData: {
                            Mobile: w.down('#phonefield').getValue(),
                        },
                        success: function (data, options) {
                            var response = JSON.parse(data.responseText);
                            console.log(response);
                            if (response.status == "success") {
                                w.hide();
                                w = Ext.create('ResetByCodeWindow');
                                w.show();
                                Ext.Msg.alert(successTitle, successMessage);
                            } else {
                                el = w.down('#error');
                                el.update(response.message);
                                el.show();
                            }
                        },
                        failure: function (response, options) {
                            console.log("failed");
                            console.log(response);
                            var responseObj = {};
                            try {    // This will fail if not valid json response
                                responseObj = Ext.decode(response.responseText);
                            } catch (e) { }
                            var error = responseObj || response.responseText,
                                el = w.down('#error');

                            el.update(error);
                            el.show();
                        },
                        callback: function () {
                            w.down('#sendCode').enable();
                            w.unmask();
                        }
                    });
                };

                handleEnter = function (field, e) {
                    if (e.getKey() == e.ENTER) {
                        sendMobileCode();
                    }
                };

                var windowTitle = MedwebCloud.getMsg('medweb.reset.window.title');
                var labelDisplayName = MedwebCloud.getMsg('medweb.user.displayname.label');

                Ext.define('SendCodeWindow', {
                    extend: 'Ext.window.Window',
                    title: document.title,
                    closable: false,
                    resizable: false,
                    draggable: false,
                    layout: 'fit',
                    width: 350,
                    border: false,
                    items: [{
                        xtype: 'form',
                        itemId: 'resetForm',
                        defaults: {
                            margin: 10,
                            anchor: '100%'
                        },
                        fieldDefaults: {
                            labelWidth: 120
                        },
                        items: [{
                            xtype: 'panel',
                            border: false,
                            layout: 'fit',
                            style: 'text-align:center',
                            html: '<img src="/images/logo.png" width="235px" height="78px" border="0" alt="Login logo" />' + (window.MWError ? '<br/><br/>' + window.MWError : ''),
                        }, {
                            xtype: 'textfield',
                            itemId: 'phonefield',
                            fieldLabel: MedwebCloud.getMsg('medweb.common.account.password.recover.mobilephone'),
                            allowBlank: false,
                            listeners: {
                                specialkey: handleEnter
                            }
                        }, {
                            xtype: 'panel',
                            hidden: true,
                            itemId: 'error',
                            border: false,
                            bodyCls: 'error'
                        }],
                    }],
                    buttons: ['->', {
                        text: MedwebCloud.getMsg('medweb.common.account.password.recover.sendsms'),
                        itemId: 'sendCode',
                        handler: sendMobileCode
                    }]
                });
                Ext.define('ResetByCodeWindow', {
                    extend: 'Ext.window.Window',
                    title: document.title,
                    closable: false,
                    resizable: false,
                    draggable: false,
                    layout: 'fit',
                    width: 350,
                    border: false,
                    items: [{
                        xtype: 'form',
                        itemId: 'changePasswordForm',
                        defaults: {
                            margin: 10,
                            anchor: '100%'
                        },
                        fieldDefaults: {
                            labelWidth: 120
                        },
                        items: [{
                            xtype: 'panel',
                            border: false,
                            layout: 'fit',
                            style: 'text-align:center',
                            html: '<img src="/images/logo.png" width="235px" height="78px" border="0" alt="Login logo" />' + (window.MWError ? '<br/><br/>' + window.MWError : ''),
                        }, {
                            xtype: 'textfield',
                            itemId: 'codefield',
                            value: '',
                            fieldLabel: MedwebCloud.getMsg('medweb.common.account.password.recover.confirmationcode'),
                            allowBlank: false,
                            listeners: {
                                specialkey: handleEnter
                            }
                        }, {
                            xtype: 'textfield',
                            itemId: 'password',
                            inputType: 'password',
                            value: '',
                            fieldLabel: MedwebCloud.getMsg('medweb.common.account.password.recover.newpassword'),
                            allowBlank: false,
                            listeners: {
                                specialkey: handleEnter
                            }
                        }, {
                            xtype: 'textfield',
                            itemId: 'confirmPassword',
                            inputType: 'password',
                            value: '',
                            fieldLabel: MedwebCloud.getMsg('medweb.user.password.confirm.label'),
                            allowBlank: false,
                            listeners: {
                                specialkey: handleEnter
                            }
                        }, {
                            xtype: 'panel',
                            hidden: true,
                            itemId: 'error',
                            border: false,
                            bodyCls: 'error'
                        }],
                    }],
                    buttons: ['->', {
                        text: MedwebCloud.getMsg('medweb.common.account.password.recover.changepassword'),
                        itemId: 'changePassword',
                        handler: changeMobilePassword
                    }]
                });
                w = Ext.create('SendCodeWindow');
                w.show();

                // make sure it stays centered
                Ext.EventManager.onWindowResize(function () {
                    w.center();
                    if (dlg.isVisible()) {
                        dlg.center();
                    }
                });
                MedwebCloud.ready = true;
            });
        }
    }
}, MedwebCloud.bundle));