﻿"use strict";

function gotoPage(index) {
    $(".alert").hide();
    if (index == 0) {
        $("#step1-panel").toggle(true);
        $("#step2-panel").toggle(false);
        $("#step3-panel").toggle(false);

        $(".nav-wizard li:nth-child(1)").addClass("active");
        $(".nav-wizard li:nth-child(2)").removeClass("active");
        $(".nav-wizard li:nth-child(3)").removeClass("active");
    } else if (index == 1) {
        $("#step2-code").text('<a href="https://' + $("#domainField").val() + '.medweb.xyz/Chat.aspx">' + $("#evisit-label").val() + '</a>').html();
        $("#step1-panel").toggle(false);
        $("#step2-panel").toggle(true);
        $("#step3-panel").toggle(false);

        $(".nav-wizard li:nth-child(1)").removeClass("active");
        $(".nav-wizard li:nth-child(2)").addClass("active");
        $(".nav-wizard li:nth-child(3)").removeClass("active");
    } else if (index == 2) {
        $("#step3-code").text('<a href="https://' + $("#domainField").val() + '.medweb.xyz/Default.aspx#evisit">' + $("#evisit-label").val() + '</a>').html();
        $("#step1-panel").toggle(false);
        $("#step2-panel").toggle(false);
        $("#step3-panel").toggle(true);

        $(".nav-wizard li:nth-child(1)").removeClass("active");
        $(".nav-wizard li:nth-child(2)").removeClass("active");
        $(".nav-wizard li:nth-child(3)").addClass("active");
    }
}

function checkConfirmPassword() {
    var passwordsMatch = $('#passwordField').val() == $('#passwordConfirmationField').val();
    if (!passwordsMatch) {
        $(".password-confirm-group").removeClass("has-success");
        $(".password-confirm-group").addClass("has-error");
        $(".password-confirm-group").addClass("has-danger");
        $("#step1-next").addClass("disabled");
    }
    else {
        $(".password-confirm-group").addClass("has-success");
        $(".password-confirm-group").removeClass("has-error");
        $(".password-confirm-group").removeClass("has-danger");
    }
    return passwordsMatch;
}

$(document).ready(function () {
    var host = location.protocol + "//" + window.location.hostname;
    var culture = $.url().param('culture');
    var cultureSuffix = "";
    if (culture) {
        cultureSuffix += "?culture=" + culture;
    }

    $("[data-hide]").on("click", function () {
        $(this).closest("." + $(this).attr("data-hide")).hide();
    });

    $("#passwordConfirmationField").keyup(function () {
        checkConfirmPassword();
    });

    $("#domainField").keyup(function () {
        var subdomain = $("#domainField").val();

        if (subdomain.length > 0) {
            var url = MedwebCloud.apiPath + "/v3/signup/checkSubdomainAvailability/" + subdomain + cultureSuffix;

            $.get(url, function (data) {
                $("#domain-error").html(data.message);

                if (data.status == "success") {
                    $(".domain-group").addClass("has-success");
                    $(".domain-group").removeClass("has-error");
                    $(".domain-group").removeClass("has-danger");
                } else {
                    $(".domain-group").removeClass("has-success");
                    $(".domain-group").addClass("has-error");
                    $(".domain-group").addClass("has-danger");
                    $("#step1-next").addClass("disabled");
                }
            });
        } else {
            $("#domain-error").html("");
        }
    });

    var clipboard = new Clipboard('.clipboard-btn');
    $("#step1-next").click(function () {
        var isValid = !$('#step1-form .has-error').length;

        var passwordsMatch = checkConfirmPassword();
        var isValid = isValid && passwordsMatch;

        if (isValid) {
            console.log("submitting data...");
            var url = MedwebCloud.apiPath + "/v3/signup" + cultureSuffix;
            var body = {
                Name: $("#nameField").val(),
                Company: $("#companyField").val(),
                Phone: $("#phoneField").val(),
                Email: $("#emailField").val(),
                Password: $("#passwordField").val(),
                DomainPrefix: $("#domainField").val()
            };
            $.post(url, JSON.stringify(body), function (data) {
                console.log(data);
                if (data.status == "success") {
                    gotoPage(1);
                }
                else {
                    $("#alert_template_message").html(data.message);
                    $('#alert_template').fadeIn('slow');
                }
            });
        }
    });

    $("#step2-next").click(function () {
        gotoPage(2);
    });

    $("#step3-previous").click(function () {
        gotoPage(1);
    });

    $("#step2-email").click(function () {
        bootbox.prompt({
            title: $("#sendEmailLabelText").val(),
            buttons: {
                confirm: {
                    label: $("#sendLabelText").val(),
                },
                cancel: {
                    label: $("#cancelLabelText").val(),
                }
            },
            onEscape: function () {
                $('.bootbox.modal').modal('hide');
            },
            callback: function (result) {
                if (!result) {
                    var url = MedwebCloud.apiPath + "/v3/signup/email/step2script" + cultureSuffix;
                    var body = {
                        Email: result,
                        Cc: $("#emailField").val(),
                        Subdomain: $("#domainField").val()
                    };
                    $.post(url, JSON.stringify(body), function (data) {
                        bootbox.alert($("#sentEmailLabelText").val());
                    });
                }
            }
        });
    });

    $("#step3-email").click(function () {
        bootbox.prompt({
            title: $("#sendEmailLabelText").val(),
            buttons: {
                confirm: {
                    label: $("#sendLabelText").val(),
                },
                cancel: {
                    label: $("#cancelLabelText").val(),
                }
            },
            onEscape: function () {
                $('.bootbox.modal').modal('hide');
            },
            callback: function (result) {
                if (result) {
                    var url = MedwebCloud.apiPath + "/v3/signup/email/step3script" + cultureSuffix;
                    var body = {
                        Email: result,
                        Cc: $("#emailField").val(),
                        Subdomain: $("#domainField").val(),
                    };
                    $.post(url, JSON.stringify(body), function (data) {
                        bootbox.alert($("#sentEmailLabelText").val());
                    });
                }
            }
        });
    });
});