﻿PRV = window.PRV || {};
PRV.joinedUsers = [];

var iOS = /(iPad|iPhone|iPod)/g.test(navigator.userAgent);
var noVideoSupport = iOS;

$(function () {
    var sub = window.location.host.split('.')[0];
    if (!PRV.websyncClient) {
        PRV.websyncClient = new fm.websync.client(MedwebCloud.websyncPath);
        PRV.websyncClient.addOnHttpRequestCreated(function (args) {
            if (args) {
                var req = args.getRequest();
                if (req) {
                    req.setRequestHeader('X-Medweb-Company', sub);
                }
            }
        })
        PRV.websyncClient.connect({
            meta: 'waitingroom'
        });
    }
    if (!PRV.restClient) {
        PRV.restClient = new fm.therest.client(MedwebCloud.apiPath);
        PRV.restClient.addOnHttpRequestCreated(function (args) {
            if (args) {
                var req = args.getRequest();
                if (req) {
                    req.setRequestHeader('X-Medweb-Company', sub);
                }
            }
        });
    }
    $(document.body).hide();

    window.MedwebCloud = window.MedwebCloud || {};


    // First, checks if it isn't implemented yet.
    if (!String.prototype.format) {
        String.prototype.format = function () {
            var args = arguments;
            return this.replace(/{(\d+)}/g, function (match, number) {
                return typeof args[number] != 'undefined' ? args[number] : match;
            });
        };
    }

    function formatString(str, col) {
        col = typeof col === 'object' ? col : Array.prototype.slice.call(arguments, 1);
        return str.replace(/\{\{|\}\}|\{(\w+)\}/g, function substitute(m, n) {
            if (m == "{{") {
                return "{";
            } if (m == "}}") {
                return "}";
            }
            return col[n] || n;
        });
    };

    function doTranslation(applicationPairs, companyPairs, callback) {
        var mwc = window.MedwebCloud;
        mwc.getMsg = function (key) {
            var template = applicationPairs[key];
            var subs = Array.prototype.slice.call(arguments, 1);
            return formatString(template, subs);
        };
        //mwc.getCompanyMsg = function (key) {
        //    var template = companyPairs[key];
        //    var subs = Array.prototype.slice.call(arguments, 1);
        //    return formatString(template, subs);
        //};
        var appRegex = /{i:([\w\.]+?)}/g;
        var compRegex = /{c:([\w\.]+?)}/g;

        function applicationSub(string) {
            if (string != null) {
                string = string.toString(10);
                return string.replace(appRegex, function ($0, $1) {
                    return applicationPairs.hasOwnProperty($1) ? applicationPairs[$1] : '{i:' + $1 + '.undefined}';
                });
            } else {
                return string;
            }
        }

        function companySub(string) {
            if (string != null) {
                string = string.toString(10);
                return string.replace(compRegex, function ($0, $1) {
                    return companyPairs.hasOwnProperty($1) ? companyPairs[$1] : '{c:' + $1 + '.undefined}';
                });
            } else {
                return string;
            }
        }
        //Preapply company substitutions
        var key;
        var hasSubs = [];
        for (key in companyPairs) {
            var value = companyPairs[key];
            value = applicationSub(value)
            value = companySub(value)
            if (compRegex.test(value)) {
                hasSubs.push(key);
            }
            companyPairs[key] = value;
        }

        var sanity = 8;

        while (hasSubs.length > 0 && sanity--) { //A company property may refer to some other company property. we do it a few times so that we can 
            var newsubs = []
            for (i = hasSubs.length; i > 0; i--) {
                key = hasSubs[i];
                var value = companyPairs[key];
                value = companySub(value)
                if (compRegex.test(value)) {
                    newsubs.push(key);
                }
                companyPairs[key] = value;
            }
            hasSubs = newsubs;
        }



        $(document).ready(function () {
            // first, translate all the "real" dom entities without destroying them all
            var re = /{i:([\w\.]+?)}/g;
            $(':contains({i:)').filter(function () {
                return $(this).children().length === 0;
            }).html(function (idx, oldHtml) {
                return applicationSub(oldHtml);
            });
            $(':contains({c:)').filter(function () {
                return $(this).children().length === 0;
            }).html(function (idx, oldHtml) {
                return companySub(oldHtml);
            });

            // then translate all the embedded content in text/html tags
            $(document.body).html(function (idx, oldHtml) {
                return applicationSub(companySub(oldHtml));
            }).show();

            if (!!callback && !!callback.call) {
                callback();
            }
        });
    } //end doTranslation


    $.get('/scripts/lang/Application_' + MedwebCloud.UIConfig.UserCulture.Name + '.txt', function (bundle) {
        // translation stuff
        var languageElements = bundle.split('\n');
        var languagePairs = {};
        for (var i = 0; i < languageElements.length; i++) {
            var pair = languageElements[i].split('=');
            if (pair.length > 1) {
                languagePairs[pair[0].trim()] = pair[1].trim();
            }
        }
        delete languageElements;
        var callback = function () {
            if ($workflow && $workflow.start) {
                $workflow.start();
            }
            function getQueryVariable(variable) {
                var query = window.location.search.substring(1);
                var vars = query.split('&');
                for (var i = 0; i < vars.length; i++) {
                    var pair = vars[i].split('=');
                    if (decodeURIComponent(pair[0]) == variable) {
                        return decodeURIComponent(pair[1]);
                    }
                }
                console.log('Query variable %s not found', variable);
            }

            var subdomain = getQueryVariable('subdomain');
            if (!subdomain) {
                subdomain = window.location.host.split('.')[0];
            }
            console.log("Using subdomain: " + subdomain);

            var checkAvailableDrs = function () {
                PRV.websyncClient.service({
                    channel: '/' + subdomain + '/waitingroom/agents',
                    onSuccess: function () {
                        // No agents are available so disable the form
                        if (arguments[0].getData() < 1) {
                            $("input, textarea, button").prop("disabled", true);
                            var errorMsg = MedwebCloud.getMsg('medweb.chat.agents.error.none');
                            $('#chatFormStatus').html(errorMsg).css('color', 'red');
                            setTimeout(checkAvailableDrs, 5000);
                        }
                        else {
                            $("input, textarea, button").prop("disabled", false);
                            var errorMsg = MedwebCloud.getMsg('medweb.cloud.evisit.visitor.instructions.label');
                            $('#chatFormStatus').html(errorMsg).css('color', '');
                        }
                    }
                });
            };

            checkAvailableDrs();


            // Animate "Waiting..." dots
            var dots = 0;

            var estimatedTime = 30; // fake it for now
            setInterval(function () {
                if (dots < 5) {
                    $('#dots').append('.');
                    dots++;
                } else {
                    $('#dots').html('');
                    dots = 0;
                }

                if (PRV.started) {
                    estimatedTime -= .25;
                    //var time = (new Date()).getTime() - estimatedTime;
                    //var seconds = time / 1000;
                    if (estimatedTime <= 0) {
                        $('#estimatedTime').html('');
                    } else {
                        var msg = MedwebCloud.getMsg('medweb.chat.connecting.time', estimatedTime.toFixed(0));
                        $('#estimatedTime').html(msg);
                    }
                }
            }, 250);

            // override jquery validate plugin defaults for bootstrap
            $.validator.setDefaults({
                highlight: function (element) {
                    $(element).closest('.form-group').addClass('has-error');
                },
                unhighlight: function (element) {
                    $(element).closest('.form-group').removeClass('has-error');
                },
                errorElement: 'span',
                errorClass: 'help-block',
                errorPlacement: function (error, element) {
                    if (element.parent('.input-group').length) {
                        error.insertAfter(element.parent());
                    } else {
                        error.insertAfter(element);
                    }
                }
            });
            var ExtraFieldPrefix = "Extra.";
            $('#chatRequestForm').submit(function (e) {
                e.preventDefault();
            }).validate({
                rules: {
                    'Name': {
                        minlength: 2,
                        required: true
                    },
                    'Email': {
                        minlength: 5,
                        email: true,
                        required: true
                    }
                },
                submitHandler: function (form) {
                    if (!$('#chatRequestForm').data('done')) {
                        return;
                    }
                    $('#pleaseWaitDialog').modal();


                    var $form = $(form);
                    var formData = $form.serializeArray();
                    var jsonData = formData.reduce(function (data, field, index, array) {
                        var fieldName = field.name,
                            fieldValue = field.value;
                        if (fieldName.indexOf(ExtraFieldPrefix) == 0) {
                            if (!data.Extra) {
                                data.Extra = {};
                            }
                            fieldName = fieldName.substr(ExtraFieldPrefix.length);
                            data.Extra[fieldName] = fieldValue;
                        } else {
                            data[fieldName] = fieldValue;
                        }
                        return data;
                    }, {
                        IsVideoSupported: !noVideoSupport
                    });

                    if (jsonData.Extra) {
                        jsonData.ExtraJson = JSON.stringify(jsonData.Extra);
                        delete jsonData.Extra;
                    }

                    console.log("still using subdomain: " + subdomain);

                    // Submit service request to get unique chat channel id
                    PRV.websyncClient.service({
                        channel: '/' + subdomain + '/waitingroom/chatRequest',
                        data: jsonData,
                        onSuccess: function (e) {
                            PRV.started = (new Date());

                            var response = e.getData();
                            var chatId = response.ChatId;
                            PRV.chatChannel = '/waitingroom/chat/' + chatId;
                            PRV.videoChannel = '/waitingroom/video/' + chatId;
                            soundManager.setup({
                                url: '/scripts/soundmanager/swf/',
                                onready: function () {
                                    soundManager.createSound({
                                        id: 'beep',
                                        url: '/sounds/beep.mp3',
                                        autoLoad: true,
                                        autoPlay: false,
                                        volume: 10
                                    });

                                    joinChat(PRV.chatChannel);
                                }
                            });
                        },
                        onFailure: function (e) {
                            $('#pleaseWaitDialog').modal('hide');
                            var msg = MedwebCloud.getMsg('medweb.chat.create.error.message');
                            bootbox.alert(msg);
                            console.log(e.getException().message);
                        }
                    });
                }
            });

            function addUser(user) {
                // TODO: extend this so it supports more users
                var username = user.getUserNickname();

                var userAlreadyInList = (PRV.joinedUsers.indexOf(username) >= 0);

                //for (var i = 0; i < PRV.joinedUsers.length; i++) {
                //    if (PRV.joinedUsers[i] == username) {
                //        userAlreadyInList = true;
                //    }
                //}
                if (!userAlreadyInList) {
                    PRV.joinedUsers.push(username);
                }

                var join = MedwebCloud.getMsg('medweb.chat.userlist.join.separator');
                var status = MedwebCloud.getMsg('medweb.chat.status.singular.message', PRV.joinedUsers.join(join));
                $('#chatStatus').html(status);
                enableChat();
                return userAlreadyInList;
            }

            function removeUser(user) {

                var username = user.getUserNickname();

                var otherUsers = false;

                var userIndex = PRV.joinedUsers.indexOf(username);
                if (userIndex >= 0) {
                    PRV.joinedUsers.splice(userIndex, 1);
                }
                return PRV.joinedUsers.length === 0;
            }

            function joinChat(channel) {
                var meDisplayName = MedwebCloud.getMsg('medweb.chat.me.displayName');

                PRV.websyncClient.join({
                    channel: channel,
                    userId: 'user',
                    userNickname: 'user',
                    /*
                                    TODO: would be nice if we dynamically detected that they've swapped from phone to browser, and now support video
                                    tag: {
                                        IsVideoSupported: !noVideoSupport
                                    },*/
                    onSuccess: function (e) {
                        $('#pleaseWaitDialog').modal('hide');

                        //console.log('Subscribed to ' + channel);
                        renderChatPanel();



                        // initialize participants list
                        var users = e.getUsers();
                        var hasAgent = false;
                        for (var i = 0; i < users.length; i++) {
                            //bootbox.alert(users[i].getUserNickname() + ' has joined.');
                            addUser(users[i]);
                        }

                        if (!noVideoSupport) {
                            sendNotice('hasVideo');
                        }

                        var messages = e.getExtensionValue('messages');

                        if (messages) {
                            for (var i = 0; i < messages.length; i++) {
                                if (messages[i].User) {
                                    addChatMessage(messages[i].Id, messages[i].Text, messages[i].User.DisplayName || messages[i].User.Username);
                                } else {
                                    addChatMessage(messages[i].Id, messages[i].Text, meDisplayName);
                                }
                            }
                        }

                        disableChat();
                        // show the waiting indicator
                        loadWaiting();
                    },
                    onFailure: function (e) {
                        $('#pleaseWaitDialog').modal('hide');
                        var msg = MedwebCloud.getMsg('medweb.chat.join.error.message');
                        bootbox.alert(msg);
                        console.log(e.getException().message);
                    },
                    onReceive: function (e) {

                        var fromMe = e.getWasSentByMe();
                        var data = e.getData();

                        if (data.notice && !fromMe) {
                            processNotice(data.notice, data);
                        }
                        else if (data.message) {
                            var userName = fromMe ? meDisplayName : e.getPublishingUser().getUserNickname();
                            addChatMessage(data.id, data.message, userName);
                            if (!fromMe) {
                                soundManager.play('beep');
                            }
                        }
                    },
                    onUserJoin: function (e) {
                        addUser(e.getJoinedUser());
                    },
                    onUserLeave: function (e) {
                        // TODO: extend this so it supports more users
                        var user = e.getLeftUser();

                        var last = removeUser(user);
                        var username = e.getLeftUser().getUserNickname();

                        var msg = MedwebCloud.getMsg('medweb.chat.leave.message', username);

                        $('#chatStatus').html(msg);
                        if (last) {
                            if (PRV.videoInProgress) {
                                PRV.videoInProgress = false;
                                PRV.endVideoChat(PRV.videoChannel, function () {

                                });
                            }
                            disableChat();
                        }
                    }
                });
            }


            var chatId = getQueryVariable('chatId');
            if (chatId) {
                $('#pleaseWaitDialog').modal();

                PRV.chatChannel = '/waitingroom/chat/' + chatId;
                PRV.videoChannel = '/waitingroom/video/' + chatId;
                joinChat(PRV.chatChannel);

                PRV.started = (new Date());
            }

            function addChatMessage(id, message, username) {
                if ($('#chatmessage_' + id).length) {
                    return;
                }
                var chatMessage = $('<div id="chatmessage_' + id + '" class="chatMessage">').html('<span class="chatUsername">' + username + ':</span>' + '<span>' + message + '</span>');

                addChatElement(chatMessage);
            }

            function addChatNotice(notice) {
                var chatNotice = $('<div class="chatNotice">').html('<span>' + notice + '</span>');

                addChatElement(chatNotice);
            }

            function addChatElement(entity) {
                $('#chatSurface').append(entity);

                $('#chatSurfaceWrap').stop().animate({
                    scrollTop: $("#chatSurfaceWrap")[0].scrollHeight
                }, 800);
            }

            function processNotice(notice, data) {
                switch (notice) {
                    case 'videoStart':
                        startVideo();

                        var msg = MedwebCloud.getMsg('medweb.chat.notice.videoStart.message');
                        addChatNotice(msg);
                        break;
                    case 'videoEnd':
                        endVideo();

                        var msg = MedwebCloud.getMsg('medweb.chat.notice.videoEnd.message');
                        addChatNotice(msg);
                        break;
                    case 'endChat':
                        var msg = MedwebCloud.getMsg('medweb.chat.notice.endChat.message');
                        var status = MedwebCloud.getMsg('medweb.chat.notice.endChat.status');
                        addChatNotice(msg)
                        $('#chatStatus').html(status);
                        if (PRV.videoInProgress) {
                            endVideo();
                        }
                        disableChat();
                        break;
                    case 'transferChat':
                        var status = data.message;
                        $('#chatStatus').html(status);

                        if (PRV.videoInProgress) {
                            endVideo();
                        }
                        disableChat();

                        var buttonText;
                        var buttonCallback;
                        if (data.link) {
                            buttonText = MedwebCloud.getMsg('medweb.chat.notice.transfer.join.text');
                            buttonCallback = function () {
                                document.location.assign(data.link);
                            }
                        } else {
                            buttonText = MedwebCloud.getMsg('medweb.chat.notice.transfer.ok.text');
                            buttonCallback = function () {
                                window.location.reload();
                            }
                        }
                        bootbox.alert({
                            message: status,
                            buttons: {
                                ok: {
                                    label: buttonText
                                }
                            },
                            callback: buttonCallback
                        });
                        break;
                    default:
                        break;
                }
            }

            function disableChat() {
                $('#chatToolbar').hide();
                $('#chatStartVideoBtn').attr("disabled", "disabled");
                $('#chatSendBtn').attr("disabled", "disabled");
                $('#chatMessageText').attr("disabled", "disabled");
                $('#active').hide();
                $('#waiting').show();
            }

            function enableChat() {
                $('#chatToolbar').show();

                $('#chatStartVideoBtn').removeAttr("disabled");
                $('#chatSendBtn').removeAttr("disabled");
                $('#chatMessageText').removeAttr("disabled");
                $('#waiting').hide();
                $('#active').show();
                // any running videos get paused
                $('#waiting video').each(function () {
                    this.pause();
                });
                if (PRV.conference) {
                    enableVideo();
                } else {
                    disableVideo();
                }
            }

            function disableVideo() {
                $('body').removeClass('active-video')
                $('#chatMuteGroup').hide();
                $('#chatEndGroup').hide();
                $('#chatStartGroup').show();
                $('#chatToolbar').show();
            }

            function enableVideo() {
                $('body').addClass('active-video')
                $('#chatToolbar').show();
                $('#chatMuteGroup').show();
                $('#chatEndGroup').show();
                $('#chatStartGroup').hide();
            }

            function startVideo(callback) {
                PRV.videoInProgress = true;
                $('#chatStartVideoBtn').attr("disabled", "disabled");
                $('body').addClass('active-video')
                //            sizeVideoContainer();
                PRV.startVideoChat(PRV.videoChannel, function () {
                    $('#chatStartVideoBtn').removeAttr("disabled");
                    enableVideo();

                    if (callback) callback();
                });
            }

            function endVideo(callback) {
                $('#chatEndVideoBtn').attr("disabled", "disabled");
                $('body').removeClass('active-video')
                PRV.endVideoChat(PRV.videoChannel, function () {
                    $('#chatEndVideoBtn').removeAttr("disabled");
                    disableVideo();
                    PRV.videoInProgress = false;
                    if (callback) callback();
                });
            }

            function renderChatPanel() {
                $('#chatRequest').hide();
                $('#chatPanel').show();

                // Handle 'Enter' keypress
                $("#chatMessageText").keyup(function (event) {
                    if (event.keyCode == 13) {
                        $("#chatSendBtn").click();
                    }
                });

                $('#chatSendBtn').click(function () {
                    var message = $('#chatMessageText').val();
                    if (message != null && message != '') {
                        sendMessage(message);
                    }
                });

                if (noVideoSupport) {
                    $('#chatStartVideoBtn').hide();
                    $('#chatEndVideoBtn').hide()
                } else {
                    if (PRV.CompanyContext && !PRV.CompanyContext.ChatRemoteCanStartVideo) {
                        $('#chatStartVideoBtn').hide();
                        $('#chatEndVideoBtn').hide()
                    } else {
                        $('#chatStartVideoBtn').show();
                        $('#chatEndVideoBtn').show()
                    }

                    $('#chatStartVideoBtn').click(function () {
                        startVideo(function () {
                            sendNotice('videoStart');
                        });
                    });

                    $('#chatEndVideoBtn').click(function () {
                        endVideo(function () {
                            sendNotice('videoEnd');
                        });
                    });

                    $('#chatMuteVideoBtn').click(function () {
                        var btn = $(this);
                        if (btn.hasClass('active')) {
                            PRV.localMedia.unmuteVideo();
                        }
                        else {
                            PRV.localMedia.muteVideo();
                        }
                        btn.toggleClass('active');
                    });

                    $('#chatMuteAudioBtn').click(function () {
                        var btn = $(this);
                        if (btn.hasClass('active')) {
                            PRV.localMedia.unmuteAudio();
                        }
                        else {
                            PRV.localMedia.muteAudio();
                        }
                        btn.toggleClass('active');
                    });

                    // Dynamically resize the video window as needed
                    $(window).resize(function () {
                        sizeVideoContainer();
                        if (PRV.layoutManager) {
                            PRV.layoutManager.doLayout();
                        }
                    }).trigger('resize');
                }
            }

            function sizeVideoContainer() {
                /*var onSmallScreen = $(window).width() <= 800;
                            
                            var aspectRatio = 0.75;
                            $('#videoContainer').width('100%');
                            var maxWidth = $('#videoContainer').width();
                            var maxHeight = maxWidth * aspectRatio;
                    
                            var windowHeight = $(window).height();
                    
                            // Enforce that it can't be taller than 50% of the viewport (25% on mobile)
                            var videoMaxHeight = onSmallScreen ? 0.25 : 0.5;
                            var scaledDownHeight = windowHeight * videoMaxHeight;
                            var scaledDownWidth = scaledDownHeight / aspectRatio;
                    
                            var height = (maxHeight > scaledDownHeight) ? scaledDownHeight : maxHeight;
                            var width = (maxHeight > scaledDownHeight) ? scaledDownWidth : maxWidth;
                    
                            $('#videoContainer').width(width);
                            $('#videoContainer').height(height);*/
            }

            function sendMessage(message) {
                PRV.websyncClient.publish({
                    channel: PRV.chatChannel,
                    data: {
                        message: message
                    },
                    onSuccess: function (e) {
                        $('#chatMessageText').val('');
                    },
                    onFailure: function (e) {
                        var msg = MedwebCloud.getMsg('medweb.chat.message.error.message');
                        bootbox.alert('Error sending message.');
                        console.log('Could not send data to ' + PRV.chatChannel);
                        console.log(e.getException().message);
                    }
                });
            }

            function sendNotice(notice) {
                PRV.websyncClient.publish({
                    channel: PRV.chatChannel,
                    data: {
                        notice: notice
                    },
                    onFailure: function (e) {
                        bootbox.alert('Error sending notice.');
                        console.log('Could not send notice to ' + PRV.chatChannel);
                        console.log(e.getException().message);
                    }
                });
            }

            /**
             Collage Login
             */
            var client = PRV.restClient;

            var btn = $('.collage-user');
            btn.addClass('collage-user-loading');

            function userIsLoggedIn(data) {
                btn.removeClass('collage-user-loading');
                btn.find('.btnText').html(data.DisplayName);
                btn.removeClass('btn-info').addClass('btn-link').prop('disabled', true);
                $('#collageUserLoginForm').modal('hide');
            }

            function userIsLoggedOut() {
                btn.removeClass('collage-user-loading');
                btn.find('.btnText').html(MedwebCloud.getMsg('medweb.cloud.evisit.visitor.login.label'));
                btn.addClass('btn-info').removeClass('btn-link').prop('disabled', false);

                if (arguments.length > 0) {
                    $("#collageUserLoginError").show().html(arguments[0]);
                } else {
                    $("#collageUserLoginError").hide();
                }
            }
            $('#collageUserLogin').submit(function (e) {
                e.preventDefault();
            }).validate({
                rules: {
                    'Username': {
                        minlength: 2,
                        required: true
                    },
                    'Password': {
                        minlength: 2,
                        required: true
                    },
                },
                submitHandler: function (form) {
                    var $form = $(form);
                    var jsonData = {};
                    $.map($form.serializeArray(), function (n, i) {
                        jsonData[n['name']] = n['value'];
                    });
                    client.send({
                        method: fm.httpMethod.Post,
                        data: jsonData,
                        path: '/v1/authenticate',
                        onSuccess: function (e) {
                            if (e.getResponseData() == null) {
                                userIsLoggedOut();
                                return;
                            }
                            else {
                                userIsLoggedIn(e.getResponseData());
                            }
                            MedwebCloud.userProfile = e.getResponseData();

                        },
                        onFailure: function (e) {
                            userIsLoggedOut(e.getException().message);
                        }
                    });
                }
            });

            client.send({
                method: fm.httpMethod.Get,
                path: '/v1/authenticate',
                onSuccess: function (e) {
                    if (e.getResponseData() == null) {
                        userIsLoggedOut();
                        return;
                    }
                    else {
                        userIsLoggedIn(e.getResponseData());
                    }
                    MedwebCloud.userProfile = e.getResponseData();
                },
                onFailure: function (e) {
                    userIsLoggedOut();
                }
            });
        }


        PRV.restClient.send({
            method: fm.httpMethod.Get,
            path: '/v2/context/' + sub,
            onSuccess: function (args) {
                var data = args.getResponseData();
                var companyData = data.CurrentContext;
                PRV.CompanyContext = $.extend({}, companyData);
                doTranslation(languagePairs, companyData, callback);
            },
            onFailure: function () {
                PRV.CompanyContext = {
                    ChatRemoteCanStartVideo: false
                };
                doTranslation(languagePairs, {}, callback);
            }
        });

    });


    $(window).on('unload', function () {
        if (PRV.websyncClient) {
            PRV.websyncClient.disconnect({
                synchronous: true
            });
        }
    });

    if (!window.console) {
        window.console = {
            log: function () {
                // just ignore it, IE junk
            }
        };
    }






});




