Ext.define('MedwebCloud.model.Contact', {
    extend: 'Ext.data.Model',
    idProperty: 'Id',
    fields: [
        { name: 'Id', type: 'int' },
        { name: 'ContactType', type: 'int' },
        { name: 'DisplayName', type: 'string' },
        { name: 'GivenName', type: 'string' },
        { name: 'FamilyName', type: 'string' },
        { name: 'MiddleName', type: 'string' },
        {
            name: 'Name', convert: function (value, record) {
                return record.get('DisplayName') ? record.get('DisplayName') : record.get('GivenName') + ' ' + record.get('FamilyName');
            }
        },
        { name: 'Suffix', type: 'string' },
        { name: 'ContactDetails', type: 'MedwebCloud.model.ContactDetail' },
        { name: 'CreatedBy', type: 'string', persist: false },
        { name: 'CreatedOn', type: 'date', persist: false, useNull: true },
        { name: 'ModifiedBy', type: 'string', persist: false },
        { name: 'ModifiedOn', type: 'date', persist: false, useNull: true },
        { name: 'IsDeleted', type: 'boolean' }
    ],
    proxy: {
        type: 'therest',
        url: MedwebCloud.api('/v1/collage/contacts')
    }
});