﻿Ext.define('MedwebCloud.model.CreateSessionModel', {
    extend: 'Ext.data.Model',
    requires: ['MedwebCloud.model.BaseInvitationModel', 'MedwebCloud.writer.JsonExtended'],
    fields: [
         { name: 'StartTime', type: 'date', useNull: true, dateFormat: 'c' }
    ],
    hasMany: [
        {
            name: 'Invitations',
            model: 'MedwebCloud.model.BaseInvitationModel',
            associationKey: 'Invitations',
            primaryKey: 'invitationId',
            foreignKey: 'sessionId'
        }],
    proxy: {
        type: 'therest',
        url: MedwebCloud.api('/v1/collage/sessions/schedule'),
        writer: {
            type: 'json-extended',
            writeAllFields: true
        }
    }
});