Ext.define('MedwebCloud.model.InternalChatMessage', {
    extend: 'Ext.data.Model',
    idProperty: 'id',
    fields: [
        { name: 'Id', type: 'int' },
        { name: 'InternalChatId', type: 'auto' },
        { name: 'UserId', type: 'string' },
        { name: 'Text', type: 'string' },
        { name: 'CreatedBy', type: 'string', persist: false },
        { name: 'CreatedOn', type: 'date', persist: false, useNull: true },
        { name: 'ModifiedBy', type: 'string', persist: false },
        { name: 'ModifiedOn', type: 'date', persist: false, useNull: true },
        { name: 'IsDeleted', type: 'boolean' }
    ],
    hasOne: [
        { name: 'User', model: 'MedwebCloud.v1.model.User', associationKey: 'User', getterName: 'getUser', setterName: 'setUser', primaryKey: 'Id', foreignKey: 'UserId' }
    ],
    proxy: {
        type: 'therest',
        url: MedwebCloud.api('/v1/internalchat/{chatId}/messages')
    }
});