﻿Ext.define('MedwebCloud.store.BaseStore', {
    extend: 'Ext.data.Store',

    //requires: ['MedwebCloud.proxy.OdataProxy'],

    autoLoad: false,

    remoteFilter: true,
    remoteSort: true,
    remoteGroup: true,

    loaded: false,
    constructor: function (config) {
        this.callParent(arguments);

        var props = Ext.apply({}, config, {
            autoLoad: false,

            remoteFilter: true,
            remoteSort: true,
            remoteGroup: true,
        });

        this.autoLoad = props.autoLoad;
        this.remoteFilter = props.remoteFilter;
        this.remoteSort = props.remoteSort;
        this.remoteGroup = props.remoteGroup;
    },
    isLoaded: function () {
        return this.loaded;
    },
    ensureLoaded: function () {
        var store = this;
        if (!store.loaded) {
            store.load();
        }
        // return the store reference to allow inlining function call.
        return store;
    },
    _preventReloadHandler: null,
    preventReloads: function () {
        var store = this;
        if (!store._preventReloadHandler) {
            store._preventReloadHandler = function (s) {
                return !s.count() > 0;
            };
            store.on('beforeload', store._preventReloadHandler);
        }

        // return the store reference to allow inlining function call.
        return store;
    },
    listeners: {
        'load': function (store, records, options) {
            this.loaded = true;
        }
    },
    needsSync: function () {
        return (this.getNewRecords().length > 0 || this.getUpdatedRecords().length > 0 || this.getRemovedRecords().length > 0);
    },
    sync: function (options) {
        options = Ext.merge({ scope: this }, options);
        var baseStore = this,
            scope = options.scope || this, //This test is now redundant
            batch = null;   // If we don't need to sync (no changes) we will fire the success callbacks with a null batch.

        if (baseStore.needsSync()) {
            // We have changes! Call the built-in ext sync handling.
            this.callParent(arguments);
        } else {
            // We don't have any changes to sync, but lets call that a
            // successful outcome anyhow and fire the success callbacks.
            if (Ext.isFunction(options.success)) {
                Ext.callback(options.success, scope, [batch, options]);
            }

            if (Ext.isFunction(options.callback)) {
                Ext.callback(options.callback, scope, [batch, options]);
            }
        }

        return baseStore;
    }
});