﻿Ext.define('MedwebCloud.ux.GridSearchBar', {
    extend: 'Ext.form.field.Text',
    xtype: 'gridsearchbar',
    alias: 'widget.gridsearchbar',
    border: 0,
    triggers: {
        clearTrigger: {
            cls: 'x-form-clear-trigger',
            handler: function () {
                this.setValue('');
            }
        }
    },
    setFilter: function (filterId, value) {
        var grid = this.up('grid');
        var store = grid.getStore();

        if (value) {
            store.removeFilter(filterId, false);
            var filter = { id: filterId, property: filterId, value: value };
            if (this.anyMatch) filter.anyMatch = this.anyMatch;
            if (this.caseSensitive) filter.caseSensitive = this.caseSensitive;
            if (this.exactMatch) filter.exactMatch = this.exactMatch;
            if (this.operator) filter.operator = this.operator;
            store.addFilter(filter);
        } else {
            store.filters.removeAtKey(filterId);
            store.reload();
        }
    },
    listeners: {
        render: function () {
            var me = this;
            me.ownerCt.on('resize', function () {
                me.setWidth(this.getEl().getWidth() - 15);
            });
        },
        change: function () {
            if (!this.getValue()) {
                var grid = this.up('grid');
                var store = grid.getStore();
                store.clearFilter();
                return;
            }
            if (this.autoSearch) {
                var column = this.up('grid').down('[dataIndex=' + this.dataIndex + ']')
                this.setFilter(column.dataIndex, this.getValue());
            }
        }
    }
});