﻿Ext.define('MedwebCloud.view.AdminPanel', {
    extend: 'Ext.panel.Panel',
    xtype: 'medwebcloud.adminpanel',
    requires: [],
    initComponent: function () {
        var me = this;

        var msg = MedwebCloud.getMsg('medweb.view.collagepanel.sessioncontainer.message');
        
        var items = [];

        if (MedwebCloud.userProfile.IsSuperAdmin) {
            items = [{
                xtype: 'tabpanel',
                flex: 1,
                items: [{
                    title: 'Users',
                    itemName: 'User',
                    itemsName: 'Users',
                    restoreEnabled: true,
                    addEnabled: false,
                    gridWidth:450,
                    xtype: 'medwebcloud.paneleditor',
                    storeType: 'MedwebCloud.store.Users',
                    storeOptions: { pageSize: 9999 },
                    formType: 'medwebcloud.userform2',
                    filters: (MedwebCloud.userProfile.IsSuperAdmin ? [] : [{
                        property: 'CompanyId',
                        operator: '=',
                        value: me.record.get("Id")
                    }]),
                    columns: [{
                        dataIndex: 'DisplayName',
                        text: 'Name',
                        flex: 2,
                        filter: [{
                            type: 'text',
                            exactMatch: false,
                        }]
                    }, {
                        dataIndex: 'Username',
                        text: 'Email',
                        flex: 2,
                        filter: [{
                            type: 'text',
                            exactMatch: false,
                        }]
                    }],
                    itemName: 'User',
                    titleFunc: function (record) {
                        return record.get("Username");
                    },
                    gridTitle: 'User List',
                    flex: 1,
                }, {
                    title: 'Companies',
                    xtype: 'medwebcloud.paneleditor',
                    storeType: 'MedwebCloud.store.Companies',
                    storeOptions: { pageSize: 9999 },
                    addForm: 'medwebcloud.addcompanyform2',
                    formType: 'medwebcloud.companyform2',
                    columns: [{
                        dataIndex: 'Name',
                        text: 'Name',
                        flex: 2,
                        filter: [{
                            type: 'text',
                            exactMatch: false,
                        }]
                    }],
                    itemName: 'Company',
                    titleFunc: function (record) {
                        return record.get("Name");
                    },
                    gridTitle: 'Company List',
                    flex: 1,
                }, {
                    title: 'Hosts',
                    xtype: 'medwebcloud.paneleditor',
                    storeType: 'MedwebCloud.store.Hosts',
                    addForm: 'medwebcloud.hostform',
                    formType: 'medwebcloud.hostform',
                    columns: [{
                        dataIndex: 'Name',
                        text: 'Name',
                        flex: 2,
                        filter: [{
                            type: 'text',
                            exactMatch: false,
                        }]
                    }],
                    itemName: 'Host',
                    titleFunc: function (record) {
                        return record.get("Name");
                    },
                    gridTitle: 'Host List',
                    flex: 1,

                }, ]
            }]


            //items = [{                
            //    xtype: 'medwebcloud.paneleditor',
            //    storeType: 'MedwebCloud.store.Companies',
            //    addForm: 'medwebcloud.addcompanyform2',
            //    formType: 'medwebcloud.companyform2',
            //    columns: [{
            //        dataIndex: 'Name',
            //        text: 'Name',
            //        flex: 2,
            //    }],
            //    itemName: 'Company',
            //    titleFunc: function (record) {
            //        return record.get("Name");
            //    },
            //    gridTitle: 'Company List',
            //    flex: 1,
            //}];
        } else if (MedwebCloud.userProfile.IsAdmin) {
            /*
            items = [{
                xtype: 'medwebcloud.companyform',
                itemId: 'companyeditor',
                model: 'MedwebCloud.model.Company',
                border: true,
                autoScroll: true,
                recordId: MedwebCloud.userProfile.CompanyId,
                formDefaults: {
                    width: 500
                },

                listeners: Ext.apply({
                    load: function (record) {
                        this.setTitle(record.get(["Name"]));
                    },
                    save: function (record) {
                        record.save();
                        record.store.reload();
                    },
                },  {})
            }]*/

            items = [{
                xtype: 'medwebcloud.formcontainer',
                formType: 'medwebcloud.companyformadmin2',
                storeType: 'MedwebCloud.store.Companies',
                storeOptions: { pageSize: 9999 },
                recordId: MedwebCloud.userProfile.CompanyId,
                border: true,
                autoScroll: true,
                layout: {
                    type: 'vbox',
                    align: 'stretch',
                    pack: 'start',
                },
                flex: 1,
            }];
        }  



        Ext.apply(me, {
            activeItem: 0,
            layout: {
                type: 'vbox',
                align: 'stretch',
                pack: 'start',
            },
            flex: 1,
            items: items
        });

        me.callParent(arguments);
    }
});