﻿Ext.define('MedwebCloud.view.BuddyGrid', {
    extend: 'Ext.grid.Panel',
    xtype: 'MedwebCloud.buddygrid',
    requires: ['MedwebCloud.view.InternalChatWindow', 'MedwebCloud.model.InternalChatInvitationModel'],
    loadMask: true,
    store: null,
    client: null,

    initComponent: function () {
        var me = this;

        var columnNameTitle = MedwebCloud.getMsg('medweb.buddygrid.column.name.title');
        var columnPresenceTitle = MedwebCloud.getMsg('medweb.buddygrid.column.presence.title');
        var columnIconTitle = MedwebCloud.getMsg('medweb.buddygrid.column.icon.title');
        console.log("BUDDY GRID!");
        Ext.apply(me, {
            autoHeight: true,
            //sortableColumns: false,
            store: me.store,
            plugins: [Ext.create('Ext.ux.grid.plugin.HeaderFilters')],
            columns: [{
                text: columnPresenceTitle,
                width: 24,
                dataIndex: 'PresenceSort',
                renderer: function (value, meta, record) {
                    var v = record.get('Presence');
                    var cls = MedwebCloud.getPresenceClassName(v);
                    return '<div class="presence ' + cls + '">&nbsp;</div>';
                }
            }, {
                dataIndex: 'DisplayName',
                text: columnNameTitle,
                flex: 1,
                //sortable: false,
                renderer: function (value, meta, record) {
                    if (!value) {
                        return record.get('Username')
                    }
                    //var html = '<b>' + value + '</b><br/>' + record.get('Username');
                    //Its nicer to have more structure in HTML, leaving the <b> and <em> for now;
                    var html = '<div class="displayName"><b>' + value + '</b></div>';
                    html += '<div class="userName">' + record.get('Username') + '</div>';
                    if (record.get('LastMessageText')) {
                        //    html += '<br/><em>' + record.get('LastMessageText') + '</em>';
                        html += '<div class="lastMessage"><em>' + record.get('LastMessageText') + '</em></div>';
                    }
                    return html;
                },
                filter: [{
                    type: 'text',
                    exactMatch: false,
                }]
            }, {
                //hideable: false,
                text: columnIconTitle,
                //sortable: false,
                dataIndex: 'GravatarImage',
                width: 40
            }]
        });

        me.callParent(arguments);
    }
});