﻿Ext.define('MedwebCloud.view.BuddyGrid', {
    extend: 'Ext.grid.Panel',
    xtype: 'MedwebCloud.buddygrid',
    loadMask: true,
    store: null,
    client: null,

    initComponent: function () {
        var me = this;
        var columnNameTitle = MedwebCloud.getMsg('medweb.buddygrid.column.name.title');
        var columnPresenceTitle = MedwebCloud.getMsg('medweb.buddygrid.column.presence.title');
        var columnIconTitle = MedwebCloud.getMsg('medweb.buddygrid.column.icon.title');

        Ext.apply(me, {
            //autoHeight: true,
            //sortableColumns: false,
            store: me.store,
            plugins: [Ext.create('Ext.ux.grid.plugin.HeaderFilters')],
            columns: [{
                enableColumnHide: false,
                menuDisabled: true,
                menuText: columnPresenceTitle,
                width: 24,
                dataIndex: 'PresenceSort',
                renderer: function (value, meta, record) {
                    var v = record.get('Presence');
                    var cls = MedwebCloud.getPresenceClassName(v);
                    return '<div class="presence ' + cls + '">&nbsp;</div>';
                }
            }, {
                enableColumnHide: false,
                menuDisabled: true,
                dataIndex: 'DisplayName',
                text: columnNameTitle,
                flex: 1,
                renderer: function (value, meta, record) {
                    //Its nicer to have more structure in HTML, leaving the <b> and <em> for now;
                    var html = '';
                    if (!!value) {
                        html += '<div class="displayName"><b>' + value + '</b></div>';
                    }
                    html += '<div class="userName">' + record.get('Username') + '</div>';
                    return html;
                },
                filter: [{
                    type: 'text',
                    exactMatch: false,
                }]
            }, {
                sortable: false,
                enableColumnHide: false,
                menuDisabled: true,
                //hideable: false,
                menuText: columnIconTitle,
                dataIndex: 'GravatarImage',
                width: 40
            }]
        });

        me.callParent(arguments);
    }
});