﻿Ext.define('MedwebCloud.view.BuddyMap', {
    extend: 'MedwebCloud.view.MapPanel',
//    extend: 'Ext.panel.Panel',
    xtype: 'MedwebCloud.buddymap',
    requires: ['MedwebCloud.view.MapPanel'],
    store: null,
    client: null,
    cls: 'map',
    initComponent: function () {
        var me = this;

        this.callParent(arguments);

        this.store.on('load', function () {
            me.plotDevices();
        });
        this.on('activate', function () {
            //me.plotDevices();
        });

        me.plotDevices();
    },

    plotDevices: function () {
        var me = this;

        this.store.each(function (user) {
            var devices = user.Devices();

            devices.each(function (device) {
                var location = device.get('Location');
                if (location) {
                    var dt = new Date(Date.parse(location.ModifiedOn));
                    var title = MedwebCloud.getMsg('medweb.view.buddymap.device.marker.text', user.get('DisplayName') , dt.toLocaleString());
                    var marker = me.addPoint(location.Latitude, location.Longitude, title, {
                        icon: MedwebCloud.getGravatarUrl(user.get('Username'), 32),
                        handler: function () {
                            me.fireEvent('itemclick', user, device, location);
                        }
                    });
                }
            });
        });
    }
});