﻿Ext.define('MedwebCloud.view.EVisitLinksGred', {
    extend: 'Ext.grid.Panel',
    xtype: 'medwebcloud.evisitlinksgrid',
    filterer: null,
    initComponent: function () {
        var me = this;

        var rowEditing = Ext.create('Ext.grid.plugin.RowEditing', {
            clicksToMoveEditor: 1,
            autoCancel: false
        });

        Ext.apply(me, {
            tbar: {
                items: [{
                    text: 'Add Link',
                    iconCls: 'addIcon',
                    handler: function () {
                        rowEditing.cancelEdit();

                        me.store.insert(0, new MedwebCloud.model.EVisitLink());

                        rowEditing.startEdit(0, 0);
                    }
                }, {
                    text: 'Remove Link',
                    itemId: 'remove',
                    disabled: true,
                    iconCls: 'deleteIcon',
                    handler: function () {
                    }
                }]
            },
            store: Ext.create('MedwebCloud.store.EVisitLinks', {
                autoLoad: true,
                filterer: me.filterer
            }),
            columns: [{
                dataIndex: 'Id',
                text: 'Id',
                width: 40
            }, {
                dataIndex: 'Enabled',
                text: 'Enabled',
                editor: {
                    xtype: 'checkbox'
                },
                renderer: function(value, meta, record){
                    return value ? 'Yes' : 'No';
                },
                width: 80
            }, {
                dataIndex: 'Name',
                text: 'Name',
                editor: {
                    allowBlank: false
                },
                flex: 1
            }, {
                dataIndex: 'Url',
                text: 'Url',
                editor: {
                    allowBlank: false
                },
                flex: 1
            }],
            plugins: [rowEditing],
            listeners: {
                'selectionchange': function (view, records) {
                    me.down('#remove').setDisabled(!records.length);
                }
            }
        });
        this.callParent(arguments);
    }
});