﻿Ext.define('MedwebCloud.view.LookingGlassForm2', {
    xtype: 'medwebcloud.lookingglassform2',
    extend: 'Ext.form.Panel',

    initComponent: function () {
        var me = this;
        var pinnedSessions = Ext.create('MedwebCloud.store.Sessions', {
            pageSize: 2147483647,
            filters: [{
                property: 'CompanyId',
                comparison: 'eq',
                value: me.customArgs['CompanyId']
            }, {
                property: 'Pinned',
                comparison: 'eq',
                value: 1
            }],
        });
        pinnedSessions.load(function () {
            this.insert(0, Ext.create('MedwebCloud.model.Session', {
                Id: 0,
                Name: 'Not Pinned'
            }));
            if (this.getCount() > 0) {
                me.down('#sessionSelect').on('enable', function (box, eOpts) {
                    box.setValue(me.record.get('PinnedSessionId') || 0);
                });
                me.down('#sessionSelect').setDisabled(false);
            } else {
                me.down('#sessionSelect').inputEl.dom.value = 'No Pinned Sessions Available';
            }
        });

        Ext.apply(me, {
            defaults: {
                anchor: '100%'
            },
            items: [{
                xtype: 'displayfield',
                fieldLabel: 'Device ID#',
                name: 'Id',
            }, {
                xtype: 'displayfield',
                fieldLabel: 'Unique Identifier',
                name: 'UniqueId',
            }, {
                xtype: 'displayfield',
                fieldLabel: 'Platform',
                name: 'DevicePlatform',
            }, {
                xtype: 'displayfield',
                fieldLabel: 'Model',
                name: 'DeviceDescription',
            }, {
                xtype: 'textfield',
                fieldLabel: 'Name',
                name: 'Name',
                allowBlank: false
            }, {
                xtype: 'combo',
                itemId: 'sessionSelect',
                fieldLabel: 'Pinned to',
                name: 'PinnedSessionId',
                xtype: 'combo',
                store: pinnedSessions,
                displayField: 'Name',
                valueField: 'Id',
                forceSelection: true,
                multiSelect: false,
                triggerAction: 'all',
                selectOnFocus: false,
                disabled: true,
                queryMode: 'local',
                lastQuery: '',
            }, {
                xtype: 'checkbox',
                fieldLabel: 'Available for <br /> Ad Hoc Sessions',
                name: 'IsAvailableAdHoc'
            }]
        });
        this.callParent(arguments);
    }
});