﻿Ext.define('MedwebCloud.view.LookingGlassSetupWizard.QRGenerator', {
    xtype: 'medwebcloud.lookingglasssetupwizard.qrgenerator',
    extend: 'Ext.form.Panel',

    initComponent: function () {
        var me = this;

        Ext.apply(this, {
            items: [{
                xtype: 'displayfield',
                fieldLabel: 'Finalize Configuration',
                labelAlign: 'top',
                name: 'sync-text',
                value: '<p>The configuration changes you have made have been condensed into the following QR Code.</p>' +
                    '<p>Enter Scan mode on a Looking Glass and scan this from approximately 18 inches away to apply these changes.</p>',
            }, {
                xtype: 'image',
                width: 600,
                height: 600,
                id: 'config-qr',
            }],
            listeners: {
                activate: function () {
                    var wiz = this.up('panel').up();
                    var data = wiz.extractData();

                    console.log("Generating QR Code for: ", data);

                    me.generateQRCode(data, function (dataSrc) {
                        try {
                            Ext.get('config-qr').dom.src = dataSrc;
                        }
                        catch (ex) {
                            console.log("Exception on QR retrieval: ", ex);
                        }
                    });
                }
            }
        });

        this.callParent(arguments);
    },
    getValues: function () {
        return null;
    },
    generateQRCode: function (jsonStr, callback) {
        var me = this;

        Ext.Ajax.request({
            url: '/GenerateCode.aspx',
            method: 'POST',
            headers: {
                'Content-Type': 'text/plain', //Mono error for app/json https://bugzilla.xamarin.com/show_bug.cgi?id=6989
            },
            jsonData: jsonStr,
            success: function (response, options) {
                //console.log(response);
                try {
                    var src = JSON.parse(response.responseText)['data'];
                    callback(src);
                }
                catch (e) {
                    console.log("Error success: ", e);
                    console.log(response);
                }
            },
            failure: function (response, options) {
                var responseObj = {};
                try {    // This will fail if not valid json response
                    responseObj = Ext.decode(response.responseText);
                } catch (e) { }
                var error = responseObj || response.responseText;;

                console.log(error);
                console.log(responseObj);

                //w.unmask();
            },
            callback: function () {
                //w.down('#login').enable();
            }
        });
    },
});