﻿Ext.define('MedwebCloud.view.LookingGlassWizardWindow', {
    xtype: 'medwebcloud.lookingglasswizardwindow',
    extend: 'Ext.window.Window',

    pages: [{ title: 'Placeholder 1', page: Ext.create('Ext.form.Panel') }, { title: 'Placeholder 2', page: Ext.create('Ext.form.Panel') }, { title: 'Summary', page: Ext.create('Ext.form.Panel') }],

    initComponent: function () {
        var me = this;

        me.oldValues = JSON.parse(JSON.stringify(me.state));
        me.newValues = JSON.parse(JSON.stringify(me.state));

        var bulletHtml = me._buildNavBullets(me.pages);

        Ext.apply(me, {
            header: {
                headerCls: 'wiz-title',
                layout: {
                    type: 'hbox',
                },
                width: '100%',
                items: [{
                    xtype: 'image',
                    src: '/images/GlassWiz_32.png',
                    width: 16,
                }, {
                    xtype: 'displayfield',
                    value: 'Looking Glass Configuration Wizard',
                }],
                height: 24,
            },
            closable: true,
            resizable: false,
            modal: true,
            draggable: true,
            //layout: 'fit',
            border: false,
            width: 640,
            height: 480,

            layout: 'border',
            itemId: 'areaContainer',
            items: [{
                //Progress Bar
                region: 'north',
                xtype: 'panel',
                layout: 'fit',
                height: 40,
                html: bulletHtml,
            }, {
                region: 'center',
                xtype: 'panel',
                layout: 'card',
                itemId: 'cardContainer',
                header: false,
                activeItem: 0,
                items: me.pages.map(function (p) { return p.page; }),
            }, {
                region: 'south',
                xtype: 'panel',
                layout: 'fit',
                header: false,
                bbar: {
                    items: [{
                        xtype: 'button',
                        hidden: true,
                        text: 'Previous',
                        iconAlign: 'left',
                        scale: 'medium',
                        cls: 'wiz-nav-bar',
                        iconCls: 'x-tbar-page-prev contain-image',
                        itemId: 'prevBtn',
                        handler: function () {
                            var layout = this.up('#areaContainer').down('#cardContainer').getLayout();
                            layout.prev();

                            var idx = this.up('#areaContainer').down('#cardContainer').items.indexOf(layout.getActiveItem());
                            me._selectNavBullet(idx);

                            if (!layout.getPrev()) {
                                this.setVisible(false);
                            } else {
                                this.up('panel').down('#doneBtn').setVisible(false);
                                this.up('panel').down('#nextBtn').setVisible(true);
                            }
                        },
                    }, '->', {
                        xtype: 'button',
                        text: 'Next',
                        iconAlign: 'right',
                        scale: 'medium',
                        cls: 'wiz-nav-bar',
                        iconCls: 'x-tbar-page-next contain-image',
                        itemId: 'nextBtn',
                        handler: function () {
                            var layout = this.up('#areaContainer').down('#cardContainer').getLayout();
                            layout.next();

                            var idx = this.up('#areaContainer').down('#cardContainer').items.indexOf(layout.getActiveItem());
                            me._selectNavBullet(idx);

                            if (!layout.getNext()) {
                                this.setVisible(false);
                                this.up('panel').down('#doneBtn').setVisible(true);
                            } else {
                                this.up('panel').down('#prevBtn').setVisible(true);
                            }
                        },
                    }, {
                        xtype: 'button',
                        text: 'Finish and Sync',
                        hidden: true,
                        iconAlign: 'left',
                        scale: 'medium',
                        cls: 'wiz-nav-bar',
                        iconCls: 'sync-glasses-icon contain-image',
                        itemId: 'doneBtn',
                        handler: function () {
                            me.fireEvent('wizardComplete', me.state);
                            me.close();
                        },
                    }],
                },
            }]
        });

        me.callParent();
    },
    _buildNavBullets: function (pages) {
        var navBullets = ['<ul id="progress-bar" class="nav nav-pills nav-wizard">'];
        for (var i = 0; i < pages.length; i++) {
            var widthPct = 1 / pages.length * 100;
            navBullets.push('<li style="width:' + widthPct + '%; pointer:default; pointer-events: none;" ');
            if (i === 0) {
                navBullets.push(' class="active"');
            }
            navBullets.push('>');
            if (i > 0) {
                navBullets.push('<div class="nav-wedge"></div>');
            }
            navBullets.push('<a href="#">' + pages[i].title + '</a>');
            if (i < pages.length - 1) {
                navBullets.push('<div class="nav-arrow"></div>');
            }
            navBullets.push('</li>');
        }
        navBullets.push('</ul>');

        return navBullets.join('');
    },
    _selectNavBullet: function (idx) {
        var progress = Ext.select('.nav-pills>li');
        var node = progress.first();
        for (var i = 0; i < idx; i++) {
            node.removeCls('active');
            node = node.next();
        }
        node.addCls('active');

        while (node = node.next()) {
            node.removeCls('active');
        }
    }
});