﻿Ext.define('MedwebCloud.view.VoicePhraseForm2', {
    xtype: 'medwebcloud.voicephraseform2',
    extend: 'Ext.form.Panel',

    initComponent: function () {
        var me = this;

        var lblName = "Phrase";//MedwebCloud.getMsg('medweb.device.name.label');
        var lblDesc = "Recognition Rate";//MedwebCloud.getMsg('medweb.device.devicedescription.label');

        var items = [{
            xtype: 'textfield',
            fieldLabel: lblName,
            allowBlank: false,
            name: 'Phrase'
        }, {
            xtype: 'panel',
            layout: 'hbox',
            items: [{
                xtype: 'slider',
                itemId: 'recogSlider',
                fieldLabel: lblDesc,
                labelWidth: 130,
                labelStyle: 'margin-top: 0px;',
                margin: '2 0 0 0',
                name: 'Sensitivity',
                minValue: 0,
                maxValue: 100,
                value: 50,
                increment: 1,
                width: 230,
                listeners: {
                    change: me.updateLabel,
                    scope: me,
                }
            }, {
                xtype: 'label',
                itemId: 'sliderValue',
                margin: '2 0 0 16',
                flex: 0.1,
            }],
            getName: function () { return me.down('#recogSlider').getName(); },
            getValue: function () { return me.down('#recogSlider').getValue(); },
            listeners: {
                afterrender: function () { me.down('#recogSlider').setValue(50); me.updateLabel(); },
            },
        }];

        Ext.apply(me, {
            defaults: {
                anchor: '100%',
                labelWidth: 130,
                border: false,
            },
            items: items,
        });

        me.callParent(arguments);
    },
    updateLabel: function () {
        var me = this;

        var slider = me.down('#recogSlider');
        var label = me.down('#sliderValue');

        label.setText(slider.getValue());
    }
});