﻿Ext.define('MedwebCloud.view.SessionsGrid', {
    extend: 'Ext.grid.Panel',
    xtype: 'MedwebCloud.sessionsgrid',

    loadMask: true,
    usersStore: null,

    initComponent: function () {
        var me = this;

        me.store = Ext.create('MedwebCloud.store.Sessions');
        var colSession = MedwebCloud.getMsg('medweb.view.sessiongrid.column.session.title')
        var colUser = MedwebCloud.getMsg('medweb.view.sessiongrid.column.user.title');
        var colDate = MedwebCloud.getMsg('medweb.view.sessiongrid.column.creationdate.title');

        Ext.apply(me, {
            title: '',
            autoHeight: true,
            sortableColumns: false,
            store: me.store,
            columns: [{
                dataIndex: 'Pinned',
                text: ' ',
                width: 20,
                renderer: function (value) {
                    return value ? '<img src="/images/pin.png" />' : '';
                }
            }, {
                dataIndex: 'SessionCode',
                text: colSession,
                flex: 1,
                renderer: function (value, meta, record) {
                    if (record.get('Pinned')) {
                        return record.get('Name') + ' (' + value + ')';
                    }
                    return value;
                }
            }, {
                dataIndex: 'CreatedBy',
                text: colUser,
                flex: 1,
                renderer: function (value) {
                    return value;
                }
            }, {
                dataIndex: 'CreatedOn',
                text: colDate,
                flex: 1,
                renderer: function (value, meta, record) {
                    return MedwebCloud.formatDate(value);
                }
            }]
        });

        me.callParent(arguments);
        me.store.load();
    }
});