﻿Ext.define('MedwebCloud.view.FormContainer', {
    extend: 'MedwebCloud.view.BaseEditorWrapper',
    xtype: 'medwebcloud.formcontainer',

    recordId: null,

    initComponent: function () {
        var me = this;

        if (!me.toolbar) {
            me.toolbar = {
                items: [Ext.apply(me.prefabs().TBtnSave, {
                    handler: function (e) {
                        me.record.set(me.getFormValues());
                        me.onOperationComplete();
                    }
                }), {
                    xtype: 'tbfill'
                }, Ext.apply(me.prefabs().TBtnCancel, {
                    handler: function (e) {
                        me.innerForm.getForm().loadRecord(me.record);
                    }
                })]
            };
        }

        Ext.apply(this, {
            tbar: me.toolbar,
        });

        this.callParent(arguments);

        me.store = Ext.create(me.storeType, me.storeOptions || {});
        me.store.load({
            callback: function (recs, op, success) {
                me.record = this.getById(me.recordId);

                //apparently toolbar.items is sometimes, a simple array?
                var items = me.toolbar.items;
                if ('items' in items) {
                    items = items.items;
                }

                me.innerForm = me.add({
                    layout: {
                        type: 'vbox',
                        align: 'stretch',
                        pack: 'start',
                    },
                    flex: 1,
                    xtype: me.formType,
                    record: me.record,
                    bodyStyle: 'padding: 10px;',
                    customArgs: me.customArgs,
                    saveButton: items[0],
                });
                me.innerForm.loadRecord(me.record);
            },
        });
    },
    getFormValues: function () {
        return this.callParent([this.innerForm]);
    },
    onOperationComplete: function (onSuccess) {
        this.callParent(arguments);
    },
});