﻿Ext.define('MedwebCloud.view.UsersGrid', {
    extend: 'Ext.grid.Panel',
    xtype: 'MedwebCloud.usersgrid',

    loadMask: true,
    usersStore: null,

    initComponent: function () {
        var me = this;
        var colName = MedwebCloud.getMsg('medweb.view.usergrid.column.name.title');
        var colUser = MedwebCloud.getMsg('medweb.view.usergrid.column.username.title');

        var lblDoctor = MedwebCloud.getMsg('medweb.user.isdoctor.label');
        var lblDepartment = MedwebCloud.getMsg('medweb.user.department.label');

        Ext.apply(me, {
            autoHeight: true,
            sortableColumns: false,
            store: Ext.create('MedwebCloud.store.Users', {
                remoteFilter: false
            }),
            columns: [{
                dataIndex: 'DisplayName',
                text: colName,
                flex: 1
            }, {
                dataIndex: 'Username',
                text: colUser,
                flex: 1
            }],
            viewConfig: {
                getRowClass: function (rec, rowIdx, params, store) {
                    return (MedwebCloud.userProfile.IsSuperAdmin || MedwebCloud.userProfile.CompanyId == rec.get("CompanyId")) ? '' : 'affiliate';
                }
            }
        });

        me.callParent(arguments);

        me.store.load();
    }
});