﻿Ext.define('MedwebCloud.view.VitalsPlusPanel', {
    xtype: 'medwebcloud.vitalspluspanel',
    extend: 'Ext.Panel',
    client: null,
    recordId: 0,
    record: null,
    initComponent: function () {
        var me = this;        

       Ext.apply(this, {
            border: true,
            cls: 'vitals-plus',
            // 2 vertical
              layout: {
                 type: 'vbox',
                 align: 'stretch'
             },
              defaults: {
                 border: true,
                 //flex: 1,
                  xtype: 'container',
                  layout: {
                     type: 'hbox',
                     align: 'stretch'
                 },
                  defaults: {
                     flex: 1,
                     cls: 'vitalsBox'
                 }
              },
              items: [{
                id: 'patient',
            },{
                 // 3 horizontal
              items: [{
                     tpl:
              '<div id="panel-' + this.recordId + '"><div id="patientID' + this.recordId + '" class="circle panelOverflow">' +
                
              '<div  class="col-md-3 col-sm-6 col-xs-12 drkblue "><ul class="vital-signs"><li class="title">BP</li>' +
              '<li class="value"><input type="label" class="vitalsInput" id="bloodPressure' + this.recordId + '" disabled="disabled"/></li>' +
              '<li class="unit">mmHg </li></ul></div>' +

              '<div class="col-md-3 col-sm-6 col-xs-12 drkblue"><ul class="vital-signs"><li class="title">RR</li>' +
              '<li class="value"><input type="label" class="vitalsInput" id="respiration' + this.recordId + '" disabled="disabled"/></li>' +
              '<li class="unit">BrPM</li></ul></div>' +

              '<div class="col-md-3 col-sm-6 col-xs-12 drkblue"><ul class="vital-signs"><li class="title">SpO2</li>' +
              '<li class="value"><input type="label" class="vitalsInput" id="oxygen' + this.recordId + '" disabled="disabled"/></li>' +
              '<li class="unit">%</li></ul></div>' +

              '<div class="col-md-3 col-sm-6 col-xs-12 drkblue "><ul class="vital-signs"><li class="title">Temp</li>' +
              '<li class="value"><input type="label" class="vitalsInput" id="temperature' + this.recordId + '" disabled="disabled"/><span class="font-small"></li>' +
              '<li class="value"><input class="font-small temperatureUnit vitalsInput" type="label"  id="temperatureDegree' + this.recordId + '" disabled="disabled"/></span></div></li>' +

              '<div class="col-md-3 col-sm-6 col-xs-12 drkblue" ><ul class="vital-signs"><li class="title">Posture</li>' +
              '<li class="value"><input type="label" class="vitalsInput" id="posture' + this.recordId + '" disabled="disabled"/></li></ul></div>' +

              '<div class="col-md-3 col-sm-6 col-xs-12 drkblue"><ul class="vital-signs"><li class="title">Steps</li>' +
              '<li class="value"><input type="label" class="vitalsInput" id="steps' + this.recordId + '" disabled="disabled"/></li></ul></div>' +

              '</div>' +

              '<div id="ecgDraw' + this.recordId + '" class="circle panelOverflow">' +

              '<div class="col-md-3 col-sm-6 col-xs-12 drkblue pull-left"><ul class="vital-signs"><li class="title">HR</li>' +
              '<li class="value"><input type="label" class="vitalsInput" id="pulse' + this.recordId + '" disabled="disabled"/></li>' +
              '<li class="unit">BPM</li></ul></div>' +

              ' <div class="divWarningMessage">ECG data not available.</div></div></div>'
                 }]
             }]

        });

        this.callParent(arguments);
        var userProfile = MedwebCloud.userProfile;
        var channel = '/VitalsPlus/' + this.record.Id;
        this.client.join({
            channel: channel,
            userId: userProfile.Id.toString(),
            userNickname: userProfile.DisplayName,
            onReceive: function (args) {
                me.updateVitals(args.getData());
            }
        });

        if (window.location.hostname.indexOf('medweb.dev') > -1 || window.location.hostname.indexOf('localhost') > -1) { // '=' added 
            var getRandomInt = function (min, max) {
                return Math.floor(Math.random() * (max - min)) + min;
            }
            window.setInterval(function () {
                me.updateVitals({
                    Name: "Doe, John",
                    PatientId: "1234",
                    Vitals: [{
                        Name: "bp",
                        Timestamp: new Date(),
                        Value: getRandomInt(60, 80) + "/" + getRandomInt(60, 80)
                    }, {
                        Name: "HR",
                        Timestamp: new Date(),
                        Value: getRandomInt(60, 80)
                    }, {
                        Name: "resp",
                        Timestamp: new Date(),
                        Value: getRandomInt(60, 80)
                    }, {
                        Name: "temp",
                        Timestamp: new Date(),
                        Value: getRandomInt(60, 80)
                    }, {
                        Name: "steps",
                        Timestamp: new Date(),
                        Value: getRandomInt(60, 80)
                    }, {
                        Name: "ecg",
                        Timestamp: new Date(),
                        Value: getRandomInt(60, 80)
                    }, {
                        Name: "oxygen",
                        Timestamp: new Date(),
                        Value: getRandomInt(60, 80)
                    }, {
                        Name: "posture",
                        Timestamp: new Date(),
                        Value: getRandomInt(60, 80)
                    }]
                });
            }, 1000);
        }

        this.on('destroy', function () {
            me.client.leave({
                channel: channel
            })
        })
    },
    onRender: function () {
        this.callParent(arguments);
        var me = this;

        // fill in all the vitals with blanks
        window.setTimeout(function () {
            me.clearVitals();
        }, 1);
    },
    clearVitals: function () {
        var items = this.queryBy(function (p) { return p.cls == 'vitalsBox' })
        for (var i = 0; i < items.length; i++) {
            var item = items[i];
            item.update({ Value: '--' });
        }
    },
    updateVitals: function (data) {
        if (data.Name) {
            heartRate = data.Vitals[0].Value;
            bodyTemperature = data.Vitals[1].Value;
            temperatureUnit = data.Vitals[1].Unit;
            respirationRate = data.Vitals[2].Value;
            steps = data.Vitals[3].Value;
            posture = data.Vitals[4].Value;
            oxygen = data.Vitals[5].Value;
            bloodPressure = data.Vitals[6].Value;
            ecg = data.Vitals[7].Value;
        }

        $('#bloodPressure' + this.recordId).val(bloodPressure);
        $('#respiration' + this.recordId).val(respirationRate);
        $('#oxygen' + this.recordId).val(oxygen);
        $('#temperature' + this.recordId).val(bodyTemperature);
        $('#posture' + this.recordId).val(posture);
        $('#steps' + this.recordId).val(steps);
        $('#pulse' + this.recordId).val(heartRate);
        $('#temperatureDegree' + this.recordId).val(temperatureUnit);

    }
});

