﻿/*
***TODO: I18N in MedwebCloud.view.WaitingRoom.SessionsGrid***
*/
Ext.define('MedwebCloud.view.WaitingRoom.SessionsGrid', {
    extend: 'Ext.grid.Panel',
    xtype: 'MedwebCloud.wr.sessionsgrid',

    loadMask: true,
    activeChatsStore: null,

    initComponent: function () {
        var me = this;

        MedwebCloud.websyncClient.subscribe({
            channel: '/' + MedwebCloud.UIConfig.CompanyContext.Subdomain + '/waitingroom/sessions',
            onSuccess: function (e) {
                /*var sessions = e.getExtensionValueJson('sessions');
                me.sessionStore.loadRawData(fm.json.deserialize(sessions));*/
            },
            onFailure: function (e) {
                /*
                var msg = MedwebCloud.getMsg('medweb.waitingroom.activechats.subscribe.failure.title');
                var title = MedwebCloud.getMsg('medweb.waitingroom.activechats.subscribe.failure.title');
                Ext.Msg.alert(title, msg);*/
            },
            onReceive: function (e) {
                me.sessionStore.load();
                /*var data = e.getData();
                if (!data.session && !data.sessionId) return;
                var store = me.sessionStore;
                if (data.sessionId){
                    if (data.action == "remove") {
                        var rec = store.findRecord('Id', data.sessionId);
                        if (rec != null) {
                            store.remove(rec);
                        }
                    }
                    return;
                }

                var records = me.parseRawRecords(data.session);
                records.forEach(function (record, index, all) {
                    var recId = records[0].get('Id');
                    try {
                        var rec = store.findRecord('Id', recId);
                        if (rec != null) {
                            store.remove(rec);
                        }
                        if (data.action == 'add') {
                            store.add(record);
                        }
                    } catch (ex) {
                        console.log("Error executing action '" + data.action + "' for Record ID: " + recId);
                    }
                });*/
            }
        });

        me.sessionStore = Ext.create('MedwebCloud.store.Sessions');
        //me.sessionStore = Ext.create('MedwebCloud.store.Sessions', { sort: [{ property: 'SessionCode', direction: 'DESC' }]});

        var columnCodeTitle = MedwebCloud.getMsg('medweb.waitingroom.sessions.grid.column.code.title')
        var columnNameTitle = MedwebCloud.getMsg('medweb.waitingroom.sessions.grid.column.name.title');

        Ext.apply(me, {
            store: me.sessionStore,
            autoHeight: true,
            columns: [
				{
				    dataIndex: 'SessionCode',
				    text: columnCodeTitle,
				    width: 50,
				}, {
				    text: columnNameTitle,
				    dataIndex: 'Name',
				    flex: 1,
				    renderer: function (value, meta, record) {
				        try {
				            var result = "<b>" + value + "</b>";
				            var active = me.getActiveParticipants(record.raw.Participants);
				            result += "<div style='font-size:smaller; color:#888;'>";

				            if (active != null && active.length > 0) {
				                result += active.reduce(function (usersString, user, pos, all) {
				                    return usersString + "<span style='white-space: nowrap'>" + user.DisplayName + "</span>" + ((all.length - pos) > 1 ? ", ": "");
				                }, "");
				            } else {
                                result += "<i>Empty</i>"
				            }
				            result += "</div>"

				            return result;
				        } catch (e) {
				            console.log(e);
				            return value;
				        }
				    }
				}
            ]
        });

        me.callParent(arguments);
        me.sessionStore.load();
    },
    parseRawRecords: function (data) {
        var me = this;
        var result = me.sessionStore.getProxy().getReader().read(data);

        return result.records;
    },

    getActiveParticipants: function (participants) {
        if (!Array.isArray(participants)) {
            if (Array.isArray(participants.Participants)) {
                participants = participants.Participants;
            } else {
                return [];
            }
        }
        var results =  participants.reduce(function (active, participant, position, all) {
            var user = participant.User;
            if (participant.Active && !participant.IsDeleted && user != null && active.ids.indexOf(user.Id) == -1) {
                active.users.push(user);
                active.ids.push(user.Id);
            }
            return active;
        }, { users: [], ids: [] });
        return results.users;
    }
});