﻿/*
***TODO: I18N in this file***
*/
Ext.define('MedwebCloud.view.WaitingRoom.SugarPanel', {
    extend: 'Ext.form.Panel',
    xtype: 'MedwebCloud.wr.sugarpanel',
    chatRequest: null,
    initComponent: function () {
        var me = this;

        Ext.apply(this, {
            tbar: {
                items: [{
                    text: 'Send Chat Logs',
                    itemId: 'sendToSugar',
                    iconCls: 'sendToCrmIcon',
                    disabled: true,
                    handler: function () {
                        Ext.Msg.wait('Please wait while the logs are saved...', 'Please wait...');
                        Ext.Ajax.request({
                            method: 'POST',
                            url: MedwebCloud.api('/sugar/' + (me.result.Contact ? 'contacts' : 'leads') + '/notes'),
                            jsonData: {
                                RecordId: me.entity.id,
                                ChatId: me.chatRequest.get('ChatId')
                            },
                            success: function () {
                                Ext.Msg.alert('Success', 'Notes have been successfully saved to Sugar.');
                            }
                        });
                    }
                }, {
                    text: 'Create Patient',
                    itemId: 'createLead',
                    iconCls: 'createLeadInCrmIcon',
                    disabled: true,
                    handler: function () {
                        Ext.Msg.wait('Please wait while the patient is created...', 'Please wait...');
                        Ext.Ajax.request({
                            method: 'POST',
                            url: MedwebCloud.api('/sugar/leads'),
                            jsonData: me.chatRequest.data,
                            success: function (response) {
                                var o = fm.json.deserialize(response.responseText);
                                me.renderEntity(o, 'lead');
                                //Ext.Msg.alert('Success', 'The lead has been successfully created in Sugar.');
                            }
                        });
                    }
                }]
            },
            bodyPadding: '5px',
            html: 'Locating record...'
        });

        me.callParent(arguments);
        me.findVisitor();
    },

    findVisitor: function () {
        var me = this;

        Ext.Ajax.request({
            method: 'POST',
            url: MedwebCloud.api('/sugar/find'),
            jsonData: {
                email: this.chatRequest.get('Email')
            },
            success: function (response) {
                // always enable after a result
                me.down('#createLead').enable();

                var o = fm.json.deserialize(response.responseText);
                if (o) {
                    // contacts supersede leads
                    var entity = null;
                    if (o.Contact) {
                        entity = o.Contact;
                    } else if (o.Lead) {
                        entity = o.Lead;
                    }
                    me.result = o;

                    if (entity) {
                        me.renderEntity(entity, o.Contact ? 'contact' : 'lead');
                    } else {
                        me.update('No record found for this user.');
                    }
                }
            }
        });
    },
    renderEntity: function (entity, type) {
        var me = this;
        var name = entity.full_name;
        var email = ' - ';
        var phone = ' - ';
        if (entity.email.length > 0) {
            email = entity.email[0].email_address;
        }

        // if there is a value from Sugar, then we can send the notes
        me.down('#sendToSugar').enable();

        var phone_options = ['_home', '_other', '_work'];
        for (var i = 0; i < phone_options.length; i++) {
            var option = phone_options[i];
            if (entity['phone' + option]) {
                phone = entity['phone' + option];
                break;
            }
        }
        me.entity = entity;
        me.update('Name: ' + name + '<br/>Email: ' + email + '<br/>Phone:' + phone);

        me.fireEvent('entityShown', entity, type);
    }
});